%t(s(A,B,C,D,E,F),s(G,B,H,D,E,F)) :- C>0, G=:=A+1, H=:=C-1.
%t(s(A,B,C,D,E,F),s(A,B,G,H,E,F)) :- C<F, H=:=D+1, G=:=C+1.
%t(s(A,B,C,D,E,F),s(A,G,H,D,E,F)) :- C>0, G=:=B+1, H=:=C-1.
%t(s(A,B,C,D,E,F),s(A,B,G,D,H,F)) :- C<F, H=:=E+1, G=:=C+1.

pred_abs(s(P,Q,A,C,D,S),P+Q-(C+D)+A=:=S).
pred_abs(s(P,Q,A,C,D,S),S>=1).
pred_abs(s(P,Q,A,C,D,S),A>0).
pred_abs(s(P,Q,A,C,D,S),A<S).

sat(s(P,Q,A,C,D,S),el_unsafe) :- P+Q-(C+D)+A<S,S>=1.
sat(s(P,Q,A,C,D,S),el_unsafe) :- P+Q-(C+D)+A>S,S>=1.


%sat(A,or(B,C)) :- sat(A,B).
%sat(A,or(B,C)) :- sat(A,C).
%sat(A,and(B,C)) :- sat(A,B), sat(A,C).
sat(A,not(B)) :- \+sat(A,B).

sat(A,ef(B)) :- sat(A,B).
sat(s(A,B,C,D,E,F),ef(G)) :- C>0, H=:=A+1, I=:=C-1, sat(s(H,B,I,D,E,F),ef(G)).
sat(s(A,B,C,D,E,F),ef(G)) :- C<F, H=:=D+1, I=:=C+1, sat(s(A,B,I,H,E,F),ef(G)).
sat(s(A,B,C,D,E,F),ef(G)) :- C>0, H=:=B+1, I=:=C-1, sat(s(A,H,I,D,E,F),ef(G)).
sat(s(A,B,C,D,E,F),ef(G)) :- C<F, H=:=E+1, I=:=C+1, sat(s(A,B,I,D,H,F),ef(G)).


%%%sat(A,eg(B)) :- \+sat(A,af(not(B))).

%%%sat(A,af(B)) :- sat(A,B).
%%%sat(s(A,B,C,D,E,F),af(P)) :- C>0,C<F,
%%%	G1=:=A+1, H1=:=C-1,
%%%	H2=:=D+1, G2=:=C+1,
%%%	G3=:=B+1, H3=:=C-1, 
%%%	H4=:=E+1, G4=:=C+1,
%%%	sat(s(G1,B,H1,D,E,F),af(P)),
%%%	sat(s(A,B,G2,H2,E,F),af(P)),
%%%	sat(s(A,G3,H3,D,E,F),af(P)),
%%%	sat(s(A,B,G4,D,H4,F),af(P)).

%%%sat(s(A,B,C,D,E,F),af(P)) :- C=<0,C<F,
%%%	H2=:=D+1, G2=:=C+1, 
%%%	H4=:=E+1, G4=:=C+1, 
%%%	sat(s(A,B,G2,H2,E,F),af(P)),
%%%	sat(s(A,B,G4,D,H4,F),af(P)).

%%%sat(s(A,B,C,D,E,F),af(P)) :- C>0,C>=F,
%%%	G1=:=A+1, H1=:=C-1,
%%%	G3=:=B+1, H3=:=C-1, 
%%%	sat(s(G1,B,H1,D,E,F),af(P)),
%%%	sat(s(A,G3,H3,D,E,F),af(P)).

safe :- A=:=S,P=:=0,Q=:=0,C=:=0,D=:=0, sat(s(P,Q,A,C,D,S),not(ef(el_unsafe))).

%%%
%%%initial def: safe1 :- A=:=S,P=:=0,Q=:=0,C=:=0,D=:=0, sat(s(P,Q,A,C,D,S),not(ef(el_unsafe))).
%%%solver: clpq
%%%uf: ctl
%%%wqounf: ctl
%%%verification: yes
%%%
%%% Spec. time: 660ms


%%%safe1 :- A=:=0, B=:=0, C=:=0, D=:=0, E=:=F,
%%% not(newsat2(A,B,E,C,D,F)).
%%%newsat2(A,B,C,D,E,F) :- newsat3(A,B,C,D,E,F).
%%%newsat2(A,B,C,D,E,F) :- G=:= -1+C,
%%% H=:=1-B-C+D+E+F, C>0, newsat4(G,H,B,D,E,F).
%%%newsat2(A,B,C,D,E,F) :- G=:= -1+C, H=:=1+B,
%%% C>0, newsat4(G,A,H,D,E,F).
%%%newsat4(A,B,C,D,E,F) :- newsat6(B,C,A,D,E,F).
%%%newsat4(A,B,C,D,E,F) :- G=:= -1+A,
%%% H=:=1-C-A+D+E+F, A>0, newsat4(G,H,C,D,E,F).
%%%newsat4(A,B,C,D,E,F) :- G=:=1+A, H=:=1+D,
%%% A-F<0, newsat4(G,B,C,H,E,F).
%%%newsat4(A,B,C,D,E,F) :- G=:= -1+A, H=:=1+C,
%%% A>0, newsat4(G,B,H,D,E,F).
%%%newsat4(A,B,C,D,E,F) :- G=:=1+A, H=:=1+E,
%%% A-F<0, newsat4(G,B,C,D,H,F).

