% taken from Delzanno CAV2000
pred_abs(s(I,D,S,E),D+S+E>=1).
pred_abs(s(I,D,S,E),I>=1).
pred_abs(s(I,D,S,E),I>=0).
pred_abs(s(I,D,S,E),D>=2).
pred_abs(s(I,D,S,E),D>=1).
pred_abs(s(I,D,S,E),D>=0).
pred_abs(s(I,D,S,E),S>=1).
pred_abs(s(I,D,S,E),S>=0).
pred_abs(s(I,D,S,E),E>=0).



sat(s(I,D,S,E),el_unsafe) :- D>=2,  I>=0,S>=0,E>=0.
sat(s(I,D,S,E),el_unsafe) :- D>=1,S>=1,  I>=0,E>=0.

sat(S, not(P)) :- \+ sat(S, P).

sat(S,ef(P)) :- sat(S,P).


sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=0,S>=0,E>=0,D+S+E>=1,
	sat(s(I,D,S,E),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=1,D>=0,S>=1,E>=0,

	I1=:=I-1,S1=:=S+1,
	sat(s(I1,D,S1,E),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=1,D>=1,S>=0,E>=0,

	I1=:=I-1,D1=:=D-1,S1=:=S+2,
	sat(s(I1,D1,S1,E),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=1,D=:=0,S=:=0,

	I1=:=I-1,E1=:=E+1,
	sat(s(I1,D,S,E1),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=0,S>=0,E>=0, D+S+E>=1,

	D1=:=1,E1=:=0,I1=:=I+E+D+S-1,S1=:=0,
	sat(s(I1,D1,S1,E1),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=1,D>=0,S>=0,E>=0,

	I1=:=E+D+I+S-1,E1=:=0,S1=:=0,D1=:=1,
	sat(s(I1,D1,S1,E1),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=1,S>=0,E>=0,

	I1=:=I+1,D1=:=D-1,
	sat(s(I1,D1,S,E),ef(P)).


sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=0,S>=0,E>=0,

	I1=:=I+1,S1=:=S-1,
	sat(s(I1,D,S1,E),ef(P)).


sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=0,S>=0,E>=0,

	I1=:=I+1,E1=:=E-1,
	sat(s(I1,D,S,E1),ef(P)).



safe :- I>=1,D=:=0,S=:=0,E=:=0,sat(s(I,D,S,E),not(ef(el_unsafe))).


%%%
%%%initial def: safe1 :- I>=1,D=:=0,S=:=0,E=:=0,sat(s(I,D,S,E),not(ef(el_unsafe))).
%%%solver: clpq
%%%uf: ctl
%%%wqounf: ctl
%%%verification: yes
%%%
%%% Spec. time: 19400ms

%%%safe1 :- A=:=0, B=:=0, C=:=0, D>=1,
%%% not(newsat2(D,A,B,C)).
%%%newsat2(A,B,C,D) :- newsat3(A,B,C,D).
%%%newsat2(A,B,C,D) :- E=:=1, F=:= -1+A,
%%% newsat4(E,F,B,C).
%%%newsat2(A,B,C,D) :- E=:=1, F=:=0, G=:=0,
%%% H=:= -1+A+C, newsat5(E,F,G,H).
%%%newsat2(A,B,C,D) :- E=:= -1+C, F=:=1+A,
%%% newsat6(E,F,B,D).
%%%newsat2(A,B,C,D) :- E=:= -1, F=:=1+A,
%%% newsat7(E,F,B,C).
%%%newsat7(A,B,C,D) :- newsat8(B,C,D,A).
%%%newsat7(A,B,C,D) :- D=:=0, E=:=1+A, F=:= -1+B,
%%% newsat9(E,F,C,D).
%%%newsat6(A,B,C,D) :- newsat10(B,C,A,D).
%%%newsat5(A,B,C,D) :- newsat11(D,A,B,C).
%%%newsat5(A,B,C,D) :- newsat5(A,B,C,D).
%%%newsat5(A,B,C,D) :- E=:= -1+A, F=:=2+B,
%%% G=:= -1+D, D>=1, newsat13(F,E,G,C).
%%%newsat5(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% H=:= -1+D+A+B, newsat5(G,E,F,H).
%%%newsat5(A,B,C,D) :- E=:=1, F=:=0, G=:=0,
%%% H=:= -1+D+A+B, D>=1, newsat15(E,F,G,H).
%%%newsat5(A,B,C,D) :- E=:= -1+A, F=:=1+D,
%%% newsat16(E,F,B,C).
%%%newsat5(A,B,C,D) :- E=:= -1+B, F=:=1+D,
%%% newsat17(E,F,A,C).
%%%newsat5(A,B,C,D) :- E=:= -1, F=:=1+D,
%%% newsat18(E,F,A,B).
%%%newsat4(A,B,C,D) :- newsat19(B,C,D,A).
%%%newsat4(A,B,C,D) :- newsat4(A,B,C,D).
%%%newsat4(A,B,C,D) :- D=:=0, E=:=1+A, A>=1,
%%% F=:= -1+B, B>=1, newsat4(E,F,C,D).
%%%newsat4(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% H=:= -1+B+D+A, newsat5(G,E,F,H).
%%%newsat4(A,B,C,D) :- E=:=1, F=:=0, G=:=0,
%%% H=:= -1+B+D+A, B>=1, newsat15(E,F,G,H).
%%%newsat4(A,B,C,D) :- E=:= -1+D, F=:=1+B,
%%% newsat24(E,F,C,A).
%%%newsat4(A,B,C,D) :- E=:= -1+A, F=:=1+B,
%%% newsat25(E,F,C,D).
%%%newsat25(A,B,C,D) :- newsat26(B,C,D,A).
%%%newsat25(A,B,C,D) :- D+A>=1, newsat27(B,C,D,A).
%%%newsat25(A,B,C,D) :- D=:=0, E=:=1+A, F=:= -1+B,
%%% newsat28(E,F,C,D).
%%%newsat25(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% D+A>=1, H=:= -1+B+D+A, newsat15(G,E,F,H).
%%%newsat25(A,B,C,D) :- E=:=1, F=:=0, G=:=0, A>=0,
%%% H=:= -1+B+D+A, newsat5(E,F,G,H).
%%%newsat25(A,B,C,D) :- E=:= -1+D, F=:=1+B, A>=0,
%%% newsat31(E,F,C,A).
%%%newsat25(A,B,C,D) :- E=:= -1+A, A>=0, F=:=1+B,
%%% newsat25(E,F,C,D).
%%%newsat24(A,B,C,D) :- newsat33(B,C,A,D).
%%%newsat18(A,B,C,D) :- newsat34(B,C,D,A).
%%%newsat17(A,B,C,D) :- newsat35(B,C,A,D).
%%%newsat16(A,B,C,D) :- newsat36(B,A,C,D).
%%%newsat16(A,B,C,D) :- A+C>=1, newsat37(B,A,C,D).
%%%newsat16(A,B,C,D) :- E=:=1, A=:=0, C=:=0,
%%% F=:= -1+B, newsat4(E,F,A,C).
%%%newsat16(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% A+C>=1, H=:= -1+B+A+C, newsat15(G,E,F,H).
%%%newsat16(A,B,C,D) :- E=:=1, F=:=0, G=:=0,
%%% H=:= -1+B+A+C, newsat5(E,F,G,H).
%%%newsat16(A,B,C,D) :- E=:= -1+C, F=:=1+B,
%%% newsat41(E,F,A,D).
%%%newsat16(A,B,C,D) :- E=:= -1, F=:=1+B,
%%% newsat42(E,F,A,C).
%%%newsat15(A,B,C,D) :- newsat43(D,A,B,C).
%%%newsat15(A,B,C,D) :- newsat15(A,B,C,D).
%%%newsat15(A,B,C,D) :- E=:= -1+A, F=:=2+B,
%%% G=:= -1+D, newsat13(F,E,G,C).
%%%newsat15(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% H=:= -1+D+A+B, newsat15(G,E,F,H).
%%%newsat15(A,B,C,D) :- E=:=1, F=:=0, G=:=0,
%%% H=:= -1+D+A+B, newsat15(E,F,G,H).
%%%newsat15(A,B,C,D) :- E=:= -1+A, F=:=1+D,
%%% newsat16(E,F,B,C).
%%%newsat15(A,B,C,D) :- E=:= -1+B, F=:=1+D,
%%% newsat17(E,F,A,C).
%%%newsat15(A,B,C,D) :- E=:= -1, F=:=1+D,
%%% newsat18(E,F,A,B).
%%%newsat13(A,B,C,D) :- newsat51(C,B,A,D).
%%%newsat13(A,B,C,D) :- newsat13(A,B,C,D).
%%%newsat13(A,B,C,D) :- E=:=1+A, F=:= -1+C, C>=1,
%%% newsat13(E,B,F,D).
%%%newsat13(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% H=:= -1+C+B+A, newsat5(G,E,F,H).
%%%newsat13(A,B,C,D) :- E=:=1, F=:=0, G=:=0,
%%% H=:= -1+C+B+A, C>=1, newsat15(E,F,G,H).
%%%newsat13(A,B,C,D) :- E=:= -1+A, F=:=1+C,
%%% newsat56(E,F,B,D).
%%%newsat13(A,B,C,D) :- E=:= -1, F=:=1+C,
%%% newsat57(E,F,B,A).
%%%newsat9(A,B,C,D) :- newsat58(B,C,D,A).
%%%newsat9(A,B,C,D) :- E=:=1+A, F=:= -1+B, B>=1,
%%% newsat28(E,F,C,D).
%%%newsat9(A,B,C,D) :- E=:=1, F=:=0, G=:=0, A>=0,
%%% H=:= -1+B+D+A, B>=1, newsat5(E,F,G,H).
%%%newsat9(A,B,C,D) :- E=:= -1+D, A>=0, F=:=1+B,
%%% newsat61(E,F,C,A).
%%%newsat9(A,B,C,D) :- E=:= -1+A, A>=0, F=:=1+B,
%%% newsat7(E,F,C,D).
%%%newsat61(A,B,C,D) :- newsat63(B,C,A,D).
%%%newsat57(A,B,C,D) :- newsat64(B,C,D,A).
%%%newsat56(A,B,C,D) :- newsat65(B,C,A,D).
%%%newsat56(A,B,C,D) :- C+A>=1, newsat66(B,C,A,D).
%%%newsat56(A,B,C,D) :- E=:=1+A, A>=1, F=:= -1+B,
%%% newsat13(E,C,F,D).
%%%newsat56(A,B,C,D) :- E=:=1, C=:=0, A=:=0,
%%% F=:= -1+B, newsat4(E,F,C,A).
%%%newsat56(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% C+A>=1, H=:= -1+B+C+A, newsat15(G,E,F,H).
%%%newsat56(A,B,C,D) :- E=:=1, F=:=0, G=:=0,
%%% H=:= -1+B+C+A, newsat5(E,F,G,H).
%%%newsat56(A,B,C,D) :- E=:= -1+A, F=:=1+B,
%%% newsat71(E,F,C,D).
%%%newsat56(A,B,C,D) :- E=:= -1, F=:=1+B,
%%% newsat72(E,F,C,A).
%%%newsat42(A,B,C,D) :- newsat73(B,C,D,A).
%%%newsat42(A,B,C,D) :- C=:=0, D=:=0, E=:=1+A,
%%% F=:= -1+B, newsat9(E,F,C,D).
%%%newsat41(A,B,C,D) :- newsat75(B,C,A,D).
%%%newsat37(A,B,C,D) :- newsat76(A,B,C,D).
%%%newsat37(A,B,C,D) :- newsat37(A,B,C,D).
%%%newsat37(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% H=:= -1+A+B+C, newsat15(G,E,F,H).
%%%newsat37(A,B,C,D) :- E=:=1, F=:=0, G=:=0,
%%% H=:= -1+A+B+C, newsat15(E,F,G,H).
%%%newsat37(A,B,C,D) :- E=:= -1+C, F=:=1+A,
%%% newsat80(E,F,B,D).
%%%newsat37(A,B,C,D) :- E=:= -1, F=:=1+A,
%%% newsat81(E,F,B,C).
%%%newsat31(A,B,C,D) :- newsat82(B,C,A,D).
%%%newsat28(A,B,C,D) :- newsat83(B,C,D,A).
%%%newsat28(A,B,C,D) :- D+A>=1, newsat4(A,B,C,D).
%%%newsat28(A,B,C,D) :- E=:=1+A, F=:= -1+B, B>=1,
%%% newsat28(E,F,C,D).
%%% newsat28(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% D+A>=1, H=:= -1+B+D+A, newsat5(G,E,F,H).
%%% newsat28(A,B,C,D) :- E=:=1, F=:=0, G=:=0,
%%% A>=0, H=:= -1+B+D+A, B>=1, newsat5(E,F,G,H).
%%% newsat28(A,B,C,D) :- E=:= -1+D, F=:=1+B, A>=0,
%%% newsat31(E,F,C,A).
%%% newsat28(A,B,C,D) :- E=:= -1+A, A>=0, F=:=1+B,
%%% newsat25(E,F,C,D).
%%% newsat27(A,B,C,D) :- newsat90(A,B,C,D).
%%% newsat27(A,B,C,D) :- newsat27(A,B,C,D).
%%% newsat27(A,B,C,D) :- C=:=0, E=:=1+D, D>=1,
%%% F=:= -1+A, newsat4(E,F,B,C).
%%% newsat27(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% H=:= -1+A+C+D, newsat15(G,E,F,H).
%%% newsat27(A,B,C,D) :- E=:=1, F=:=0, G=:=0,
%%% H=:= -1+A+C+D, newsat15(E,F,G,H).
%%% newsat27(A,B,C,D) :- E=:= -1+C, F=:=1+A,
%%% newsat24(E,F,B,D).
%%% newsat27(A,B,C,D) :- E=:= -1+D, F=:=1+A,
%%% newsat25(E,F,B,C).
%%% newsat81(A,B,C,D) :- newsat97(B,C,D,A).
%%% newsat80(A,B,C,D) :- newsat98(B,C,A,D).
%%% newsat72(A,B,C,D) :- newsat99(B,C,D,A).
%%% newsat72(A,B,C,D) :- C=:=0, D=:=0, E=:=1+A,
%%% F=:= -1+B, newsat9(E,F,C,D).
%%% newsat71(A,B,C,D) :- newsat101(B,C,A,D).
%%% newsat71(A,B,C,D) :- C+A>=1,
%%% newsat66(B,C,A,D).
%%% newsat71(A,B,C,D) :- E=:=1+A, A>=1, F=:= -1+B,
%%% newsat13(E,C,F,D).
%%% newsat71(A,B,C,D) :- E=:=1, C=:=0, A=:=0,
%%% F=:= -1+B, newsat4(E,F,C,A).
%%% newsat71(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% C+A>=1, H=:= -1+B+C+A, newsat15(G,E,F,H).
%%% newsat71(A,B,C,D) :- E=:=1, F=:=0, G=:=0,
%%% A>=0, H=:= -1+B+C+A, newsat5(E,F,G,H).
%%% newsat71(A,B,C,D) :- E=:= -1+A, A>=0, F=:=1+B,
%%% newsat71(E,F,C,D).
%%% newsat71(A,B,C,D) :- E=:= -1, F=:=1+B, A>=0,
%%% newsat72(E,F,C,A).
%%% newsat66(A,B,C,D) :- newsat109(A,B,C,D).
%%% newsat66(A,B,C,D) :- newsat66(A,B,C,D).
%%% newsat66(A,B,C,D) :- E=:=1+C, C>=1, F=:= -1+A,
%%% newsat13(E,B,F,D).
%%% newsat66(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% H=:= -1+A+B+C, newsat15(G,E,F,H).
%%% newsat66(A,B,C,D) :- E=:=1, F=:=0, G=:=0,
%%% H=:= -1+A+B+C, newsat15(E,F,G,H).
%%% newsat66(A,B,C,D) :- E=:= -1+C, F=:=1+A,
%%% newsat71(E,F,B,D).
%%% newsat66(A,B,C,D) :- E=:= -1, F=:=1+A,
%%% newsat72(E,F,B,C).