% Finite state system, Nilsson-Lubcke CL2000
% LNAI 1861 pp. 384-398

t(0,1).
t(1,1).
t(0,2).
t(2,3).
t(3,2).


%sat(X,geq2) :- X>=2.

sat(2,geq2).
sat(3,geq2).


sat(S0, or(F1,F2)) :- sat(S0, F1).
sat(S0, or(F1,F2)) :- sat(S0, F2).

sat(S0, and(F1, F2)) :-  sat(S0, F1), sat(S0, F2).

sat(S0, not(F)) :- \+ sat(S0, F).

sat(S, ef(X)) :- sat(S,X).
sat(S, ef(X)) :- t(S,S1), sat(S1,ef(X)).

sat(S, eg(X)) :-  \+ sat(S,af(not(X))).

sat(S,af(X)) :- sat(S,X).

sat(S,af(X)) :- t(S,S1), \+ a(S,X).
a(S,X) :- t(S,S1), \+ sat(S1,af(X)).  %not stratified but call-consistent



p :- sat(0,ef(eg(geq2))).