% taken from Delzanno CAV2000

pred_abs(s(I,S,E,M),I>=1).
pred_abs(s(I,S,E,M),I>=0).
pred_abs(s(I,S,E,M),S>=1).
pred_abs(s(I,S,E,M),S>=0).
pred_abs(s(I,S,E,M),S=:=0).
pred_abs(s(I,S,E,M),E>=1).
pred_abs(s(I,S,E,M),E>=0).
pred_abs(s(I,S,E,M),E=:=0).
pred_abs(s(I,S,E,M),M>=2).
pred_abs(s(I,S,E,M),M>=1).
pred_abs(s(I,S,E,M),M>=0).
pred_abs(s(I,S,E,M),M=:=0).
pred_abs(s(I,S,E,M),I+S>=1).
pred_abs(s(I,S,E,M),S+M+E>=1).


sat(s(_,_,_,M),el_unsafe) :- M>=2.
sat(s(_,S,_,M),el_unsafe) :- M>=1,S>=1.

sat(S, not(P)) :- \+ sat(S, P).

sat(S,ef(P)) :- sat(S,P).

sat(s(I,S,E,M),ef(P)) :-
	I>=0,S>=0,M>=0,E>=0, S+M+E>=1,
	sat(s(I,S,E,M),ef(P)).

sat(s(I,S,E,M),ef(P)) :-
	I>=1,S>=0,E>=0,M>=0,
	
	I1=:=I-1,
	S1=:=S+M+E+1,
	E1=:=0,
	M1=:=0,
	sat(s(I1,S1,E1,M1),ef(P)).	

sat(s(I,S,E,M),ef(P)) :-
	M>=1,I>=0,E>=0,S>=0,
	
	sat(s(I,S,E,M),ef(P)).	

sat(s(I,S,E,M),ef(P)) :-
  I>=0,S>=0,M>=0,E>=1,
  
  E1=:=E-1,M1=:=M+1,
  sat(s(I,S,E1,M1),ef(P)).	

sat(s(I,S,E,M),ef(P)) :- 
   I+S>=1, I>=0,S>=0,E>=0,M>=0,
	
	I1=:=I+S+E+M-1,S1=:=0,E1=:=1,M1=:=0,
	sat(s(I1,S1,E1,M1),ef(P)).	

sat(s(I,S,E,M),ef(P)) :-
	I>=0,S>=0,M>=0,E>=1,

	E1=:=E-1,I1=:=I+1,
	sat(s(I1,S,E1,M),ef(P)).	

sat(s(I,S,E,M),ef(P)) :-
    I>=0,S>=1,M>=0,E>=0,
	 
	 S1=:=S-1,I1=:=I+1,
	 sat(s(I1,S1,E,M),ef(P)).	

sat(s(I,S,E,M),ef(P)) :-
    I>=0,S>=0,M>=1,E>=0,

	 M1=:=M-1,I1=:=I+1,
	 sat(s(I1,S,E,M1),ef(P)).	


safe :- I>=0,S=:=0,E=:=0,M=:=0,sat(s(I,S,E,M),not(ef(el_unsafe))).


%%%
%%%initial def: safe1 :-  I>=0,S=:=0,E=:=0,M=:=0,sat(s(I,S,E,M),not(ef(el_unsafe))).
%%%solver: clpq
%%%uf: ctl
%%%wqounf: ctl
%%%verification: yes
%%%
%%% Spec. time: 6800ms

%%%safe1 :- A=:=0, B=:=0, C=:=0, D>=0,
%%% not(newsat2(D,A,B,C)).
%%%newsat2(A,B,C,D) :- newsat3(A,B,C,D).
%%%newsat2(A,B,C,D) :- E=:=0, F=:=0, G=:=1,
%%% H=:= -1+A, A>=1, newsat4(E,F,G,H).
%%%newsat2(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+A, A>=1, newsat5(E,F,G,H).
%%%newsat5(A,B,C,D) :- newsat6(D,C,B,A).
%%%newsat5(A,B,C,D) :- newsat5(A,B,C,D).
%%%newsat5(A,B,C,D) :- E=:=0, F=:=0, G=:=1+B,
%%% H=:= -1+D, D>=1, newsat8(E,F,G,H).
%%%newsat5(A,B,C,D) :- E=:=1, F=:= -1+B,
%%% newsat9(E,F,D,C).
%%%newsat5(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+D+B, D>=1, newsat10(E,F,G,H).
%%%newsat5(A,B,C,D) :- E=:= -1+B, F=:=1+D,
%%% newsat11(F,E,C,A).
%%%newsat4(A,B,C,D) :- newsat12(D,C,B,A).
%%%newsat4(A,B,C,D) :- newsat4(A,B,C,D).
%%%newsat4(A,B,C,D) :- E=:=0, F=:=0, G=:=1+C,
%%% H=:= -1+D, D>=1, newsat8(E,F,G,H).
%%%newsat4(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+D+C, newsat5(E,F,G,H).
%%%newsat4(A,B,C,D) :- E=:= -1+C, F=:=1+D,
%%% newsat16(F,E,B,A).
%%%newsat16(A,B,C,D) :- newsat17(A,B,C,D).
%%%newsat16(A,B,C,D) :- E=:=0, F=:=0, G=:=1+B,
%%% H=:= -1+A, newsat4(E,F,G,H).
%%%newsat16(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+A+B, newsat5(E,F,G,H).
%%%newsat11(A,B,C,D) :- newsat20(A,C,B,D).
%%%newsat11(A,B,C,D) :- E=:=0, F=:=0, G=:=1+B,
%%% H=:= -1+A, newsat4(E,F,G,H).
%%%newsat11(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+A+B, newsat5(E,F,G,H).
%%%newsat10(A,B,C,D) :- newsat23(D,C,B,A).
%%%newsat10(A,B,C,D) :- newsat10(A,B,C,D).
%%%newsat10(A,B,C,D) :- E=:=0, F=:=0, G=:=1+B,
%%% H=:= -1+D, newsat8(E,F,G,H).
%%%newsat10(A,B,C,D) :- E=:=1, F=:= -1+B,
%%% newsat26(E,F,D,C).
%%%newsat10(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+D+B, newsat10(E,F,G,H).
%%%newsat10(A,B,C,D) :- E=:= -1+B, F=:=1+D,
%%% newsat11(F,E,C,A).
%%%newsat9(A,B,C,D) :- newsat29(C,D,B,A).
%%%newsat9(A,B,C,D) :- newsat9(A,B,C,D).
%%%newsat9(A,B,C,D) :- E=:=0, F=:=0, G=:=1+B+A,
%%% H=:= -1+C, C>=1, newsat8(E,F,G,H).
%%%newsat9(A,B,C,D) :- newsat9(A,B,C,D).
%%%newsat9(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+C+B+A, C>=1, newsat10(E,F,G,H).
%%%newsat9(A,B,C,D) :- E=:= -1+A, F=:=1+C,
%%% newsat34(F,E,D,B).
%%%newsat8(A,B,C,D) :- newsat35(D,C,B,A).
%%%newsat8(A,B,C,D) :- newsat8(A,B,C,D).
%%%newsat8(A,B,C,D) :- E=:=0, F=:=0, G=:=1+C,
%%% H=:= -1+D, D>=1, newsat8(E,F,G,H).
%%%newsat8(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+D+C, newsat10(E,F,G,H).
%%%newsat8(A,B,C,D) :- E=:= -1+C, F=:=1+D,
%%% newsat39(F,E,B,A).
%%%newsat39(A,B,C,D) :- newsat40(A,B,C,D).
%%%newsat39(A,B,C,D) :- newsat39(A,B,C,D).
%%%newsat39(A,B,C,D) :- E=:=0, F=:=0, G=:=1+B,
%%% H=:= -1+A, newsat8(E,F,G,H).
%%%newsat39(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+A+B, newsat10(E,F,G,H).
%%%newsat39(A,B,C,D) :- E=:= -1+B, F=:=1+A,
%%% newsat44(F,E,C,D).
%%%newsat34(A,B,C,D) :- newsat45(A,C,D,B).
%%%newsat34(A,B,C,D) :- D+B>=1, newsat46(A,C,D,B).
%%%newsat34(A,B,C,D) :- E=:=0, F=:=0, G=:=1+D+B,
%%% H=:= -1+A, newsat47(E,F,G,H).
%%%newsat34(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+A+D+B, newsat5(E,F,G,H).
%%%newsat26(A,B,C,D) :- newsat49(C,D,B,A).
%%%newsat26(A,B,C,D) :- newsat26(A,B,C,D).
%%%newsat26(A,B,C,D) :- E=:=0, F=:=0, G=:=1+B+A,
%%% H=:= -1+C, newsat8(E,F,G,H).
%%%newsat26(A,B,C,D) :- newsat26(A,B,C,D).
%%%newsat26(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+C+B+A, newsat10(E,F,G,H).
%%%newsat26(A,B,C,D) :- E=:= -1+A, F=:=1+C,
%%% newsat34(F,E,D,B).
%%%newsat47(A,B,C,D) :- newsat55(D,C,B,A).
%%%newsat47(A,B,C,D) :- newsat47(A,B,C,D).
%%%newsat47(A,B,C,D) :- E=:=0, F=:=0, G=:=1+C,
%%% H=:= -1+D, D>=1, newsat8(E,F,G,H).
%%%newsat47(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+D+C, newsat5(E,F,G,H).
%%%newsat47(A,B,C,D) :- E=:= -1+C, F=:=1+D,
%%% newsat44(F,E,B,A).
%%%newsat46(A,B,C,D) :- newsat60(A,B,C,D).
%%%newsat46(A,B,C,D) :- newsat46(A,B,C,D).
%%%newsat46(A,B,C,D) :- E=:=0, F=:=0, G=:=1+C+D,
%%% H=:= -1+A, newsat8(E,F,G,H).
%%%newsat46(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+A+C+D, newsat10(E,F,G,H).
%%%newsat44(A,B,C,D) :- newsat64(A,B,C,D).
%%%newsat44(A,B,C,D) :- B>=1, newsat39(A,B,C,D).
%%%newsat44(A,B,C,D) :- E=:=0, F=:=0, G=:= -1+A,
%%% H=:=1+B, newsat47(E,F,H,G).
%%%newsat44(A,B,C,D) :- E=:=0, F=:=1, G=:=0,
%%% H=:= -1+A+B, newsat5(E,F,G,H).
%%%newsat44(A,B,C,D) :- E=:=1+A, F=:= -1+B, B>=1,
%%% newsat44(E,F,C,D).
