% Microwave oven example
% "Model Checking" Clarke, Grumberg, Peled p.39


%%% State 1 s(0,0,0,0)
%%% State 2 s(1,0,0,1)
%%% State 3 s(0,1,0,0)
%%% State 4 s(0,1,1,0)
%%% State 5 s(1,1,0,1)
%%% State 6 s(1,1,0,0)
%%% State 7 s(1,1,1,0)


t(s(0,0,0,0),s(1,0,0,1)). % 1->2 start oven
t(s(0,0,0,0),s(0,1,0,0)). % 1->3 close door
t(s(1,0,0,1),s(1,1,0,1)). % 2->5 close door
t(s(0,1,0,0),s(0,0,0,0)). % 3->1 open door
t(s(0,1,0,0),s(1,1,0,0)). % 3->6 start oven
t(s(0,1,1,0),s(0,1,1,0)). % 4->4 cook
t(s(0,1,1,0),s(0,0,0,0)). % 4->1 open door
t(s(0,1,1,0),s(0,1,0,0)). % 4->3 done
t(s(1,1,0,1),s(1,0,0,1)). % 5->2 open door
t(s(1,1,0,1),s(0,1,0,0)). % 5->3 reset
t(s(1,1,0,0),s(1,1,1,0)). % 6->7 warmup
t(s(1,1,1,0),s(0,1,1,0)). % 7->4 start cooking

sat(s(1,Close,Heat,Error),start).
sat(s(Start,1,Heat,Error),close).
sat(s(Start,Close,1,Error),heat).
sat(s(Start,Close,Heat,1),error).




sat(S0, or(F1,F2)) :- sat(S0, F1).
sat(S0, or(F1,F2)) :- sat(S0, F2).

sat(S0, and(F1, F2)) :-  sat(S0, F1), sat(S0, F2).

sat(S0, not(F)) :- \+ sat(S0, F).

sat(S, ef(X)) :- sat(S,X).
sat(S, ef(X)) :- t(S,S1), sat(S1,ef(X)).

sat(S, eg(X)) :-  \+ sat(S,af(not(X))).

sat(S,af(X)) :- sat(S,X).

sat(S,af(X)) :- t(S,S1), \+ a(S,X).
a(S,X) :- t(S,S1), \+ sat(S1,af(X)).  %not stratified but call-consistent



p :- sat(s(0,0,0,0),not(ef(and(start,eg(not(heat)))))).