pred_abs(s(_,_,B,C,T,S),B=<S).
pred_abs(s(_,_,B,C,T,S),C=<S).

%pred_abs(s(_,_,B,C,T,S),B=<S+1).
%pred_abs(s(_,_,B,C,T,S),C=<S+1).

%pred_abs(s(_,_,B,C,D,E),D=:=E).
%pred_abs(s(_,_,B,C,D,E),B=:=0).
%pred_abs(s(_,_,B,C,D,E),C=:=0).

%pred_abs(s(_,_,B,C,D,E),D<E).

pred_abs(s(_,_,B,C,D,E),D>=0).
pred_abs(s(_,_,B,C,D,E),E>=0).

%pred_abs(s(_,_,B,C,D,E),B>=0).
%pred_abs(s(_,_,B,C,D,E),C>=0).

%pred_abs(s(_,_,B,C,D,E), B=:=D+1).
%pred_abs(s(_,_,B,C,D,E), C=:=D+1).


%%%t(s(t,P,A,B,T,S),s(w,P,T,B,T1,S)) :- T>=0, T1=:=T+1.
%%%t(s(w,P,A,B,T,S),s(u,P,A,B,T,S)) :- A=<S.
%%%t(s(u,P,A,B,T,S),s(t,P,A,B,T,S1)) :- S>=0, S1=:=S+1.
%%%% symmetrical transitions
%%%t(s(P,t,A,B,T,S),s(P,w,A,T,T1,S)) :- T>=0, T1=:=T+1.
%%%t(s(P,w,A,B,T,S),s(P,u,A,B,T,S)) :- B=<S.
%%%t(s(P,u,A,B,T,S),s(P,t,A,B,T,S1)) :- S>=0, S1=:=S+1.


sat(s(u,u,A,B,S,T),el_unsafe).
sat(s(w,P,A,B,S,T),el_wait).
sat(s(u,P,A,B,S,T),el_use).



sat(A,or(B,C)) :- sat(A,B).
sat(A,or(B,C)) :- sat(A,C).
sat(A,and(B,C)) :- sat(A,B), sat(A,C).
sat(A,not(B)) :- \+sat(A,B).

sat(A,ef(B)) :- sat(A,B).
sat(s(t,A,B,C,D,E),ef(F)) :- D>=0, G=:=D+1, sat(s(w,A,D,C,G,E),ef(F)).
sat(s(w,A,B,C,D,E),ef(F)) :- B=<E, sat(s(u,A,B,C,D,E),ef(F)).
sat(s(u,A,B,C,D,E),ef(F)) :- E>=0, G=:=E+1, sat(s(t,A,B,C,D,G),ef(F)).
sat(s(A,t,B,C,D,E),ef(F)) :- D>=0, G=:=D+1, sat(s(A,w,B,D,G,E),ef(F)).
sat(s(A,w,B,C,D,E),ef(F)) :- C=<E, sat(s(A,u,B,C,D,E),ef(F)).
sat(s(A,u,B,C,D,E),ef(F)) :- E>=0, G=:=E+1, sat(s(A,t,B,C,D,G),ef(F)).

sat(A,eg(B)) :- \+sat(A,af(not(B))).

sat(A,af(B)) :- sat(A,B).

sat(s(t,t,A,B,T,S),af(P)) :- T>=0, T1=:=T+1,
	sat(s(w,t,T,B,T1,S),af(P)), 
	sat(s(t,w,A,T,T1,S),af(P)).
sat(s(t,w,A,B,T,S),af(P)) :- T>=0, T1=:=T+1, B=<S,
	sat(s(w,w,T,B,T1,S),af(P)), 
	sat(s(t,u,A,B,T,S),af(P)).
sat(s(t,w,A,B,T,S),af(P)) :- T>=0, T1=:=T+1, B>S,
	sat(s(w,w,T,B,T1,S),af(P)).
sat(s(t,u,A,B,T,S),af(P)) :- T>=0, T1=:=T+1, S>=0, S1=:=S+1,
	sat(s(w,u,T,B,T1,S),af(P)), 
	sat(s(t,t,A,B,T,S1),af(P)).

sat(s(w,t,A,B,T,S),af(P)) :- T>=0, T1=:=T+1, A=<S,
	sat(s(u,t,A,B,T,S),af(P)),
	sat(s(w,w,A,T,T1,S),af(P)). 
sat(s(w,t,A,B,T,S),af(P)) :- T>=0, T1=:=T+1, A>S,
	sat(s(w,w,A,T,T1,S),af(P)).
sat(s(w,w,A,B,T,S),af(P)) :- A=<S, B=<S,
	sat(s(u,w,A,B,T,S),af(P)),
	sat(s(w,u,A,B,T,S),af(P)).
sat(s(w,w,A,B,T,S),af(P)) :- A>S, B=<S,
	sat(s(w,u,A,B,T,S),af(P)).
sat(s(w,w,A,B,T,S),af(P)) :- A=<S, B>S,
	sat(s(u,w,A,B,T,S),af(P)).
sat(s(w,u,A,B,T,S),af(P)) :- S>=0, S1=:=S+1, A=<S,
	sat(s(u,u,A,B,T,S),af(P)),
	sat(s(w,t,A,B,T,S1),af(P)).
sat(s(w,u,A,B,T,S),af(P)) :- S>=0, S1=:=S+1, A>S,
	sat(s(w,t,A,B,T,S1),af(P)).

sat(s(u,t,A,B,T,S),af(P)) :- T>=0, T1=:=T+1, S>=0, S1=:=S+1,
	sat(s(t,t,A,B,T,S1),af(P)),
	sat(s(u,w,A,T,T1,S),af(P)). 
sat(s(u,w,A,B,T,S),af(P)) :- S>=0, S1=:=S+1, B=<S,
	sat(s(u,u,A,B,T,S),af(P)),
	sat(s(t,w,A,B,T,S1),af(P)).
sat(s(u,w,A,B,T,S),af(P)) :- S>=0, S1=:=S+1, B>S,
	sat(s(t,w,A,B,T,S1),af(P)).

sat(s(u,u,A,B,T,S),af(P)) :- S>=0, S1=:=S+1,
	sat(s(t,u,A,B,T,S1),af(P)),
	sat(s(u,t,A,B,T,S1),af(P)).


%%%sat(A,af(B)) :- t(A,C), \+a(A,B).
%%%a(A,B) :- t(A,C), \+sat(C,af(B)).

safe :- A=:=0, B=:=0, T=:=S, sat(s(t,t,A,B,T,S),not(ef(el_unsafe))).
starvfree :- A=:=0, B=:=0, T=:=S, sat(s(t,t,A,B,T,S),not(ef(and(el_wait,not(af(el_use)))))).
