allinterval(N,Xs) :-
	length(Xs,N),
	differences(Xs,Ds),
	generate_list(N,Values),
	clpdelete(Values,0,Values0),
	myperm(Xs,Values),
	myperm(Ds,Values0).
%	myperm(Ds,Values0), % slightly slower
%	myperm(Xs,Values).


length([],L) :- {L=:=0}.
length([X|Xs],L) :- {L1>=0, L=:=L1+1}, length(Xs,L1).

myperm([],_).
myperm([X|Xs],Ys) :- select(X, Ys, Zs), myperm(Xs,Zs).

select(X, Ys, Zs):- clplabel(X,Ys), clpdelete(Ys,X,Zs).

clplabel(X,[Y|_Ys]) :- {X=:=Y}.
clplabel(X,[Y|Ys]) :- {X=\=Y}, clplabel(X,Ys).


clpdelete([], _, []).
clpdelete([Head|Tail], Element, Rest) :-
        {Head=:=Element},
        clpdelete(Tail, Element, Rest).
clpdelete([Head|Tail], Element, [Head|Rest]) :-
	{Head=\=Element},
        clpdelete(Tail, Element, Rest).



differences([X,Y],[DXY]) :-
	{D=:=X-Y},mymod(D,DXY).
differences([X,Y|L],[DXY|Ds]) :-
	{D=:=X-Y},mymod(D,DXY),differences([Y|L],Ds).

mymod(X,M) :- {X>=0,M=:=X}.
mymod(X,M) :- {X<0,M=:=(-X)}.

generate_list(N,[]) :- {N<0}.
generate_list(N,[N|L1]) :-
	{N>=0,N1=:=N-1}, generate_list(N1,L1).

