:- use_module(library(lists),[
			      member/2,
			      permutation/2,
			      select/3,
			      nth0/4,
			      reverse/2
			     ]).
:- use_module(library(clpq)).


%%%allinterval(N,Xs) :-
%%%	generate_list(N,LN0),
%%%	permutation(LN0,Xs),
%%%	differences(Xs,Ds),
%%%%	select(0,LN0,LN1), 
%%%%	nth0(_,LN0,0,LN1), 
%%%%	delete(LN0,0,LN1), % do not work as expected
%%%	reverse(LN0,L0N), L0N=[0|L1N],
%%%	permutation(L1N,Ds).

allinterval(N,Xs) :-
	length(Xs,N),
	differences(Xs,Ds),
	generate_list(N,Values),
	clpdelete(Values,0,Values0),
	myperm(Xs,Values),
	myperm(Ds,Values0).
%	myperm(Ds,Values0), % slightly slower
%	myperm(Xs,Values).


	

myperm([],_).
myperm([X|Xs],Ys) :- select(X, Ys, Zs), myperm(Xs,Zs).

select(X, Ys, Zs):- clpmember(X,Ys), clpdelete(Ys,X,Zs).

clpmember(X,[Y|_Ys]) :- {X=Y}.
clpmember(X,[_|Ys]) :- clpmember(X,Ys).


clpdelete([], _, []).
clpdelete([Head|Tail], Element, Rest) :-
        {Head=Element},!,
        clpdelete(Tail, Element, Rest).
clpdelete([Head|Tail], Element, [Head|Rest]) :-
%	Head=Element,
        clpdelete(Tail, Element, Rest).



differences([X,Y],[DXY]) :-
	{D=X-Y},mymod(D,DXY).
differences([X,Y|L],[DXY|Ds]) :-
	{D=X-Y},mymod(D,DXY),differences([Y|L],Ds).

mymod(X,M) :- {X>=0,M=X}.
mymod(X,M) :- {X<0,M=(-X)}.

generate_list(N,[]) :- {N<0}.
generate_list(N,L) :-
	{N>=0,N1=N-1},L=[N|L1], generate_list(N1,L1).

