% Initial definition
% nc(S,E,N,D,M,O,R,Y) :-
%           cry([[D,N,E,S],[E,R,O,M],[Y,E,N,O,M]],[S,E,N,D,M,O,R,Y]).
% Solver clp(Q)
% Unfold leftmost_determinate
% Wqounf embed_body
% Wqogen embed
% Widening simple


cry([Xs,Ys,Zs],Diff):-
  solve(Xs, Ys, Zs, [0],Carries),
  last(Xs,LXs), {LXs>0},
  last(Ys,LYs), {LYs>0},
  last(Zs,LZs), {LZs>0},
  bits(Carries),
  gendiff(Diff,[0,1,2,3,4,5,6,7,8,9]).

solve([], [], [],  [Carry|Cs],[Carry|Cs]) :- {Carry=:=0}.
solve([], [], [Z|Zs], [Carry|Cs],OCs):-
  {Carry =:= Z + Carry1*10},
  solve([], [], Zs, [Carry1,Carry|Cs],OCs).
solve([], [Y], [Z|Zs], [Carry|Cs],OCs):-
  {Y + Carry =:= Z + Carry1*10},
  solve([], [], Zs, [Carry1,Carry|Cs],OCs).
solve([X], [], [Z|Zs], [Carry|Cs],OCs):-
   {X + Carry =:= Z + Carry1*10},
  solve([], [], Zs, [Carry1,Carry|Cs],OCs).
solve([X|Xs], [Y|Ys], [Z|Zs], [Carry|Cs],OCs):-
   {X + Y + Carry =:= Z + Carry1*10},
  solve(Xs, Ys, Zs, [Carry1,Carry|Cs],OCs).

bits([]).
bits([D|Ds]) :- member(D,[0,1]), bits(Ds).

member(X,[Y|_]) :- {X=:=Y}.
member(X,[_|Ys]) :- member(X,Ys).

last([X],X).
last([X,Y|L],Z) :- last([Y|L],Z).

gendiff([],Dom).
gendiff([X|Xs],Dom1) :- del(X,Dom1,Dom2), gendiff(Xs,Dom2).

del(X1,[X2|Xs],Xs) :- {X1=:=X2}.
del(X,[Y|Ys],[Y|Zs]) :- del(X,Ys,Zs).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% specialized program
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nc(A,B,C,D,1,F,G,H) :- {D+B=:=H+I*10},
     {C+G+I=:=B+J*10}, {B+F+J=:=C+K*10},
     {A+K=:=F+9},
     {A>0}, 

     member(K,[0,1]),
     member(J,[0,1]), member(I,[0,1]),

%     del(A,[1,2,3,4,5,6,7,8,9],K1),
     ndel1(A,K1),
%     del(B,[0|K1],L),
     ndel2(B,K1,L),
     del(C,L,M), del(D,M,N),
%     del(1,N,O),
     ndel3(N,O),
     del(F,O,P), del(G,P,Q), del(H,Q,R).


ndel1(A,[2,3,4,5,6,7,8,9]) :- {A=:=1}.
ndel1(A,[1|B]) :- newdel1(B,A).
newdel1([3,4,5,6,7,8,9],A) :- {A=:=2}.
newdel1([2|A],B) :- newdel2(A,B).
newdel2([4,5,6,7,8,9],A) :- {A=:=3}.
newdel2([3|A],B) :- newdel3(A,B).
newdel3([5,6,7,8,9],A) :- {A=:=4}.
newdel3([4|A],B) :- newdel4(A,B).
newdel4([6,7,8,9],A) :- {A=:=5}.
newdel4([5|A],B) :- newdel5(A,B).
newdel5([7,8,9],A) :- {A=:=6}.
newdel5([6|A],B) :- newdel6(A,B).
newdel6([8,9],A) :- {A=:=7}.
newdel6([7|A],B) :- newdel7(A,B).
newdel7([9],A) :- {A=:=8}.
newdel7([8|A],B) :- newdel8(A,B).
newdel8([],A) :- {A=:=9}.


ndel2(A,B,B) :- {A=:=0}.
ndel2(A,B,[0|C]) :- newdel1_1(C,A,B).
newdel1_1(A,B,[C|A]) :- {C=:=B}.
newdel1_1([A|B],C,[A|D]) :- newdel1_1(B,C,D).


ndel3([A|B],B) :- {A=:=1}.
ndel3([A|B],[A|C]) :- ndel3(B,C).

