%Assumption: all atoms in Prog are pure (i.e. of the form p(X1,...,Xn)
%where  X1,...,Xn are distinct variables.

:- table holds/1, possible/1.
:- dynamic myclause/2.

:- op(500,xfx,lt), op(500,xfx,gt), op(500,xfx,le), op(500,xfx,le), op(500,xfx,eq).

holds([]).
holds([A|Ls]) :-
%        pure_atom(A),
        myclause([A|B]),
        holds(B),
        holds(Ls).
holds([not(A)|Ls]) :-
        tnot(possible([A])),
        holds(Ls).

possible([]).
possible([C|Ls]) :-
        constraint(C),
        possible(Ls).
possible([A|Ls]) :-
%        pure_atom(A),
        myclause([A|B]),
        possible(B),
        possible(Ls).
possible([not(A)|Ls]) :-
        tnot(holds([A])),
        possible(Ls).


%myclause([H|B]) :- clause(H,B). % prog(Prog), mymember(C,Prog).

constraint(C) :- functor(C,F,_A), mymember(F,[eq,geq,leq,gt,lt,=,<,>,>=,=<]).

mymember(C,[C|_Cs]).
mymember(C,[_D|Cs]) :- mymember(C,Cs).
