%Assumption: all atoms in Prog are pure (i.e. of the form p(X1,...,Xn)
%where  X1,...,Xn are distinct variables.

:- table holds/2.
:- table possible/2.


holds([],Prog).
holds([A|Ls],Prog) :-
%        pure_atom(A),
        clause([A|B],Prog),
        holds(B,Prog),
        holds(Ls,Prog).
holds([not(A)|Ls],Prog) :-
        tnot(possible(A,Prog)),
        holds(Ls,Prog).

possible([],Prog).
possible([C|Ls],Prog) :-
        constraint(C),
        possible(Ls,Prog).
possible([A|Ls],Prog) :-
%        pure_atom(A),
        clause([A|B],Prog),
        possible(B,Prog),
        possible(Ls,Prog).
possible([not(A)|Ls],Prog) :-
        tnot(holds(A,Prog)),
        possible(Ls,Prog).


myclause(C,[C|Cs]).
myclause(C,[D|Cs]) :- myclause(C,Cs).

constraint(C) :- functor(C,F,2), mymember(F,['=:=','>','<','=<','>=']).

mymember(C,[C|Cs]).
mymember(C,[D|Cs]) :- mymember(C,Cs).
