
mode(a_match,[+,+,+]).
mode(app,[-,-,+]).
mode(dist,[+,+,-]).
mode(leq,[+,+]).


a_match(S,T,K) :-
        app(X,Right,T),
        app(Left,P,X),
        dist(S,P,D),
        leq(D,K).

app([],L,L).
app([A|L1],L2,[A|L3]):-
        app(L1,L2,L3).

dist([],[],0).
dist([X|Xs],[X|Ys],D) :- dist(Xs,Ys,D).
%dist([X|Xs],[Y|Ys],s(D)) :- \+ X=Y, dist(Xs,Ys,D).
dist([a|Xs],[b|Ys],s(D)) :- dist(Xs,Ys,D).
dist([b|Xs],[a|Ys],s(D)) :- dist(Xs,Ys,D).

leq(0,Y).
leq(s(X),s(Y)) :- leq(X,Y).



%%% solver:none
%%% uf: leftmost_weak_consumer
%%% wqounf: none
%%% sp_am(A) :- a_match([a,a,b],A,s(s(0))).

%%% newp16(A).
%%% newp13(A).
%%% newp12(A).
%%% sp_am(A) :- newp2(A).
%%% newp2([a|A]) :- newp3(A).
%%% newp2([b|A]) :- newp4(A).
%%% newp2([A|B]) :- \+A=a, \+A=b, \+A=a, \+A=b,
%%%  newp2(B).
%%% newp4([b|A]) :- newp6(A).
%%% newp4([a|A]) :- newp7(A).
%%% newp4([A|B]) :- \+A=b, \+A=a, \+A=b, \+A=a,
%%%  newp2(B).
%%% newp3([b|A]) :- newp9(A).
%%% newp3([a|A]) :- newp7(A).
%%% newp3([A|B]) :- \+A=b, \+A=a, \+A=b, \+A=a,
%%%  newp2(B).
%%% newp9([a|A]) :- newp12(A).
%%% newp9([b|A]) :- newp13(A).
%%% newp9([A|B]) :- \+A=a, \+A=b, \+A=a, \+A=b,
%%%  newp2(B).
%%% newp7([a|A]) :- newp12(A).
%%% newp7([b|A]) :- newp16(A).
%%% newp7([A|B]) :- \+A=a, \+A=b, \+A=a, \+A=b,
%%%  newp2(B).
%%% newp6([a|A]) :- newp7(A).
%%% newp6([b|A]) :- newp13(A).
%%% newp6([A|B]) :- \+A=a, \+A=b, \+A=a, \+A=b,
%%%     newp2(B).
