%%%mode(match,[+,+]).
%%%mode(app,[-,-,+]).
%%%mode(match_int,[+,+,+]).


match(A,K,B) :- app(C,D,B), app(E,F,C), match_int(A,K,F).

app([],A,A).
app([A|B],C,[A|D]) :- app(B,C,D).

match_int([],_,[]).
match_int([A|B],K,[C|D]) :-
	{A>=C,
	A-C=<K}, match_int(B,K,D).
match_int([A|B],K,[C|D]) :- {A<C,C-A=<K}, match_int(B,K,D).


%%% solver:clpq
%%% uf: leftmost_weak_consumer
%%% wqounf: none

match1(A) :- {Z=:=0, D=:=2}, match([D,Z],D,A).

sp_match1_10(A).
sp_match1_8(A).
sp_match1(A) :- sp_match1_2(A).
sp_match1_2([A|B]) :- {A>=0, A=<2}, sp_match1_3(B).
sp_match1_2([A|B]) :- {A<0}, sp_match1_2(B).
sp_match1_2([A|B]) :- {A>2, A=<4}, sp_match1_3(B).
sp_match1_2([A|B]) :- {A>4}, sp_match1_2(B).
sp_match1_3([A|B]) :- {A>2, A=<4}, sp_match1_3(B).
sp_match1_3([A|B]) :- {A>0, A=<2}, sp_match1_8(B).
sp_match1_3([A|B]) :- {A=:=0}, sp_match1_8(B).
sp_match1_3([A|B]) :- {A>= -2, A<0}, sp_match1_10(B).
sp_match1_3([A|B]) :- {A< -2}, sp_match1_2(B).
sp_match1_3([A|B]) :- {A>4}, sp_match1_2(B).



/*
{U=:=1, C=:=5}, match1([C,C,C,C,C,C,C,C,C,C,
		 C,C,C,C,C,C,C,C,C,C,
		 C,C,C,C,C,C,C,C,C,C,
		 C,C,C,C,C,C,C,C,C,C,
		 C,C,C,C,C,C,C,C,C,C,
		 C,C,C,C,C,C,C,C,C,C,
		 C,C,C,C,C,C,C,C,C,C,
		 C,C,C,C,C,C,C,C,C,C,
		 C,C,C,C,C,C,C,C,C,C,
		 C,C,C,C,C,C,C,C,C,C,U,U]).


% above query takes 3380ms  (repeated 10  times)
% specialized version takes 90ms
% Speedup 37.6

{D=:=2, C=:=5, U=:=1}, match1([D,C,D,C,D,C,D,C,D,C,
                 D,C,D,C,D,C,D,C,D,C,
                 D,C,D,C,D,C,D,C,D,C,
                 D,C,D,C,D,C,D,C,D,C,
                 D,C,D,C,D,C,D,C,D,C,
                 D,C,D,C,D,C,D,C,D,C,
                 D,C,D,C,D,C,D,C,D,C,
                 D,C,D,C,D,C,D,C,D,C,
                 D,C,D,C,D,C,D,C,D,C,
                 D,C,D,C,D,C,D,C,D,C,U,U]).


% above query takes  4490ms  (repeated 10 times)
% specialized version takes 80ms
% Speedup 56.1

*/

match2(A) :- {Z=:=0, D=:=2, Q=:=4, T=:=3}, match([D,Z,Q],T,A).

sp_match2_21(A).
sp_match2_19(A).
sp_match2_14(A).
sp_match2(A) :- sp_match2_2(A).
sp_match2_2([A|B]) :- {A>= -1, A=<2}, sp_match2_3(B).
sp_match2_2([A|B]) :- {A< -1}, sp_match2_2(B).
sp_match2_2([A|B]) :- {A>2, A=<5}, sp_match2_3(B).
sp_match2_2([A|B]) :- {A>5}, sp_match2_2(B).
sp_match2_3([A|B]) :- {A>2, A=<3}, sp_match2_7(B).
sp_match2_3([A|B]) :- {A>3, A=<5}, sp_match2_3(B).
sp_match2_3([A|B]) :- {A>0, A=<2}, sp_match2_7(B).
sp_match2_3([A|B]) :- {A>= -1, A=<0}, sp_match2_7(B).
sp_match2_3([A|B]) :- {A>= -3, A< -1}, sp_match2_11(B).
sp_match2_3([A|B]) :- {A< -3}, sp_match2_2(B).
sp_match2_3([A|B]) :- {A>5}, sp_match2_2(B).
sp_match2_11([A|B]) :- {A>=1, A=<2}, sp_match2_14(B).
sp_match2_11([A|B]) :- {A>= -1, A<1}, sp_match2_3(B).
sp_match2_11([A|B]) :- {A< -1}, sp_match2_2(B).
sp_match2_11([A|B]) :- {A>2, A=<4}, sp_match2_14(B).
sp_match2_11([A|B]) :- {A>4, A=<5}, sp_match2_14(B).
sp_match2_11([A|B]) :- {A>5, A=<7}, sp_match2_19(B).
sp_match2_11([A|B]) :- {A>7}, sp_match2_2(B).
sp_match2_7([A|B]) :- {A>=1, A=<2}, sp_match2_21(B).
sp_match2_7([A|B]) :- {A>= -1, A=<0}, sp_match2_7(B).
sp_match2_7([A|B]) :- {A>0, A<1}, sp_match2_7(B).
sp_match2_7([A|B]) :- {A>= -3, A< -1}, sp_match2_11(B).
sp_match2_7([A|B]) :- {A< -3}, sp_match2_2(B).
sp_match2_7([A|B]) :- {A>2, A=<3}, sp_match2_21(B).
sp_match2_7([A|B]) :- {A>3, A=<4}, sp_match2_14(B).
sp_match2_7([A|B]) :- {A>4, A=<5}, sp_match2_14(B).
sp_match2_7([A|B]) :- {A>5, A=<7}, sp_match2_19(B).
sp_match2_7([A|B]) :- {A>7}, sp_match2_2(B).


/*
{D=:=2, O=:=8}, match2([D,D,O,D,O,D,D,O,D,O,
                        D,D,O,D,O,D,D,O,D,O,
                        D,D,O,D,O,D,D,O,D,O,
                        D,D,O,D,O,D,D,O,D,O,
                        D,D,O,D,O,D,D,O,D,O,
                        D,D,O,D,O,D,D,O,D,O,
                        D,D,O,D,O,D,D,O,D,O,
                        D,D,O,D,O,D,D,O,D,O,
                        D,D,O,D,O,D,D,O,D,O,
                        D,D,O,D,O,D,D,O,D,O,D,D,D]).


% above query takes  5480ms  (repeated 10 times)
% specialized version takes 120ms
% Speedup 45.7
*/			