
%%%mode(match,[+,+]).
%%%mode(app,[-,-,+]).
%%%mode(less_string,[+,+]).


match(A,B) :- app(C,D,B), app(E,F,C), less_string(A,F).
app([],A,A).
app([A|B],C,[A|D]) :- app(B,C,D).
less_string([],[]).
less_string([A|B],[C|D]) :- {A=<C}, less_string(B,D).


%%% solver:clpq
%%% uf: leftmost_weak_consumer
%%% wqounf: none
match1(A) :- {U=:=1, Z=:=0, D=:=2}, match([U,Z,D],A).


sp_match1_11(A).
sp_match1_8(A).
sp_match1(A) :- sp_match1_2(A).
sp_match1_2([A|B]) :- {A>=1}, sp_match1_3(B).
sp_match1_2([A|B]) :- {A<1}, sp_match1_2(B).
sp_match1_3([A|B]) :- {A>=1}, sp_match1_5(B).
sp_match1_3([A|B]) :- {A>=0, A<1}, sp_match1_6(B).
sp_match1_3([A|B]) :- {A<0}, sp_match1_2(B).
sp_match1_6([A|B]) :- {A>=2}, sp_match1_8(B).
sp_match1_6([A|B]) :- {A>=1, A<2}, sp_match1_3(B).
sp_match1_6([A|B]) :- {A<1}, sp_match1_2(B).
sp_match1_5([A|B]) :- {A>=2}, sp_match1_11(B).
sp_match1_5([A|B]) :- {A>=1, A<2}, sp_match1_5(B).
sp_match1_5([A|B]) :- {A>=0, A<1}, sp_match1_6(B).
sp_match1_5([A|B]) :- {A<0}, sp_match1_2(B).


/*

{D=:= 2, Z=:=0}, match1([D,D,Z,D,D,Z,D,D,Z,Z,
                          D,D,Z,D,D,Z,D,D,Z,Z,
                          D,D,Z,D,D,Z,D,D,Z,Z,
                          D,D,Z,D,D,Z,D,D,Z,Z,
                          D,D,Z,D,D,Z,D,D,Z,Z,
                          D,D,Z,D,D,Z,D,D,Z,Z,
                          D,D,Z,D,D,Z,D,D,Z,Z,
                          D,D,Z,D,D,Z,D,D,Z,Z,
                          D,D,Z,D,D,Z,D,D,Z,Z,
                          D,D,Z,D,D,Z,D,D,Z,Z,D,D,D]).


% above query takes  1920ms (repeated 5000  times)
% specialized version takes 700ms
% Speedup 2.74

*/








match2(A) :- {U=:=1, Z=:=0, D=:=2}, match([U,D,Z],A).

sp_match2_10(A).
sp_match2_9(A).
sp_match2_8(A).
sp_match2(A) :- sp_match2_2(A).
sp_match2_2([A|B]) :- {A>=1}, sp_match2_3(B).
sp_match2_2([A|B]) :- {A<1}, sp_match2_2(B).
sp_match2_3([A|B]) :- {A>=2}, sp_match2_5(B).
sp_match2_3([A|B]) :- {A>=1, A<2}, sp_match2_3(B).
sp_match2_3([A|B]) :- {A<1}, sp_match2_2(B).
sp_match2_5([A|B]) :- {A>=2}, sp_match2_8(B).
sp_match2_5([A|B]) :- {A>=1, A<2}, sp_match2_9(B).
sp_match2_5([A|B]) :- {A>=0, A<1}, sp_match2_10(B).
sp_match2_5([A|B]) :- {A<0}, sp_match2_2(B).


match3(A) :- {U=:=1, Z=:=0, D=:=2}, match([U,Z,D,U,Z],A).

sp_match3_27(A).
sp_match3_26(A).
sp_match3_24(A).
sp_match3_23(A).
sp_match3_22(A).
sp_match3(A) :- sp_match3_2(A).
sp_match3_2([A|B]) :- {A>=1}, sp_match3_3(B).
sp_match3_2([A|B]) :- {A<1}, sp_match3_2(B).
sp_match3_3([A|B]) :- {A>=1}, sp_match3_5(B).
sp_match3_3([A|B]) :- {A>=0, A<1}, sp_match3_6(B).
sp_match3_3([A|B]) :- {A<0}, sp_match3_2(B).
sp_match3_6([A|B]) :- {A>=2}, sp_match3_8(B).
sp_match3_6([A|B]) :- {A>=1, A<2}, sp_match3_3(B).
sp_match3_6([A|B]) :- {A<1}, sp_match3_2(B).
sp_match3_5([A|B]) :- {A>=2}, sp_match3_11(B).
sp_match3_5([A|B]) :- {A>=1, A<2}, sp_match3_5(B).
sp_match3_5([A|B]) :- {A>=0, A<1}, sp_match3_6(B).
sp_match3_5([A|B]) :- {A<0}, sp_match3_2(B).
sp_match3_11([A|B]) :- {A>=2}, sp_match3_15(B).
sp_match3_11([A|B]) :- {A>=1, A<2}, sp_match3_16(B).
sp_match3_11([A|B]) :- {A>=0, A<1}, sp_match3_6(B).
sp_match3_11([A|B]) :- {A<0}, sp_match3_2(B).
sp_match3_8([A|B]) :- {A>=1}, sp_match3_16(B).
sp_match3_8([A|B]) :- {A>=0, A<1}, sp_match3_6(B).
sp_match3_8([A|B]) :- {A<0}, sp_match3_2(B).
sp_match3_16([A|B]) :- {A>=2}, sp_match3_22(B).
sp_match3_16([A|B]) :- {A>=1, A<2}, sp_match3_23(B).
sp_match3_16([A|B]) :- {A>=0, A<1}, sp_match3_24(B).
sp_match3_16([A|B]) :- {A<0}, sp_match3_2(B).
sp_match3_15([A|B]) :- {A>=2}, sp_match3_26(B).
sp_match3_15([A|B]) :- {A>=1, A<2}, sp_match3_27(B).
sp_match3_15([A|B]) :- {A>=0, A<1}, sp_match3_24(B).
sp_match3_15([A|B]) :- {A<0}, sp_match3_2(B).