% mmod(I,J,M) holds iff
% M is |I| + |I+1| + ... + |J-2| + |J-1|

%
% Initial definition
%            mmod_s(I,J,M) :- I=:=0, J>=0, mmod(I,J,M).
% Solver clp(Q)
% Unfold leftmost_determinate
% Wqounf leftmost_predicate
% Wqogen leftmost_predicate
% Widening simple


mmod(I,J,M) :- {I>=J, M=:=0}.
mmod(I,J,M) :- {I<J, I1=:=I+1, M=:=M1+L}, mymod(I,L), mmod(I1,J,M1).
mymod(X,M) :- {X>=0, M=:=X}.
mymod(X,M) :- {X<0, M=:=(-X)}.


mmod_pe(I,J,M) :- {I=:=0, J=<0, M=:=0}.
mmod_pe(I,J,M) :- {I=:=0, J>0, I1=:=1}, genp_pe(I1,J,M).
genp_pe(I,J,M) :- {I>=J, M=:=0}.
genp_pe(I,J,M) :- {I>=0, I<J, I2=:=I+1}, genp_pe(I2,J,M2), {M=:=M2+I}.

mmod_s_ccr(I,J,M) :- {J=<0, M=:=0}.
mmod_s_ccr(I,J,M) :- {J>0, I1=:=1}, genp_ccr(I1,J,M).
genp_ccr(I,J,M) :- {I>=J, M=:=0}.
genp_ccr(I,J,M) :- {I<J, I2=:=I+1}, genp_ccr(I2,J,M2), {M=:=M2+I}.