mode(m_match,[+,+,+]).
mode(match,[+,+,+]).
mode(app,[-,-,+]).
mode(match_int,[+,+,+]).


m_match([W|Ws],K,T) :-
	match(W,K,T).
m_match([W|Ws],K,T) :-
	m_match(Ws,K,T).

match(W,K,T) :-
	app(Z,_,T),       
	app(Left,W1,Z),
	match_int(W,K,W1).


app([],L,L).
app([A|L1],L2,[A|L3]):-
	app(L1,L2,L3).


match_int([],_,[]).
match_int([A|B],K,[C|D]) :-
	A>=C,
	A-C=<K,
	match_int(B,K,D).
match_int([A|B],K,[C|D]) :-
	A<C,C-A=<K,
	match_int(B,K,D).



%%% solver:clpq
%%% uf: leftmost_weak_consumer
%%% wqounf: none
%%% Z=:=0, U=:=1, D=:=2, T=:=3, Q=:=4,

%%% sp_mm(A) :-  U=:=1, D=:=2, m_match([[U,U],[U,D]],U,A).

%%% newp11(A).
%%% newp8(A).
%%% newp7(A).
%%% sp_mm(A) :- newp2(A).
%%% newp2([A|B]) :- A>=0, A=<1, newp3(B).
%%% newp2([A|B]) :- A<0, newp2(B).
%%% newp2([A|B]) :- A>1, A=<2, newp3(B).
%%% newp2([A|B]) :- A>2, newp2(B).
%%% newp3([A|B]) :- A>1, A=<2, newp7(B).
%%% newp3([A|B]) :- A=:=1, newp8(B).
%%% newp3([A|B]) :- A>=0, A<1, newp7(B).
%%% newp3([A|B]) :- A<0, newp2(B).
%%% newp3([A|B]) :- A>2, A=<3, newp11(B).
%%% newp3([A|B]) :- A>3, newp2(B).

%%% solver:clpq
%%% uf: leftmost_consumer_atom
%%% wqounf: none
%%% Z=:=0, U=:=1, D=:=2, T=:=3, Q=:=4,

%%% sp_mm(A) :-  U=:=1, D=:=2, m_match([[U,U],[U,D]],U,A).

%%%sp_mm(A) :- newp2(A).
%%%newp2([A|B]) :- A>1, A=<2, newp3(B).
%%%newp2([A|B]) :- A>=0, A=<1, newp3(B).
%%%newp2([A|B]) :- A<0, newp2(B).
%%%newp2([A|B]) :- A>2, newp2(B).
%%%newp3([A|B]) :- newp2(B).
%%%newp3([A|B]) :- A>=0, A=<1.
%%%newp3([A|B]) :- A>=1, A=<2.
%%%newp3([A|B]) :- A>2, A=<3.

%%% solver:clpq
%%% uf: leftmost_consumer_atom
%%% wqounf: none
%%% split_cfacts: on
%%% sp_mm(A) :-  U=:=1, D=:=2, m_match([[U,U],[U,D]],U,A).

%%% sp_mm(A) :- newp2(A).
%%% newp2([A|B]) :- A>1, A=<2, newp3(B).
%%% newp2([A|B]) :- A>=0, A=<1, newp3(B).
%%% newp2([A|B]) :- A<0, newp2(B).
%%% newp2([A|B]) :- A>2, newp2(B).
%%% newp3([A|B]) :- A=:=1.
%%% newp3([A|B]) :- A>=0, A<1.
%%% newp3([A|B]) :- A>1, A=<2.
%%% newp3([A|B]) :- A>2, A=<3.
%%% newp3([A|B]) :- A<0, newp2(B).
%%% newp3([A|B]) :- A>3, newp2(B).




%%% TODO
%%% sp_mm(A) :-  U=:=1, D=:=2, m_match([[U,U,U],[U,U,D]],D,A).
%%% sp_mm(A) :-  U=:=1, D=:=2, m_match([[U,U,U],[U,U,D],[U,U]],D,A).
%%% sp_mm(A) :-  U=:=1, D=:=2,  T=:=3, m_match([[U,U,D],[U,D,T]],D,A).
%%% sp_mm(A) :-  U=:=1, D=:=2,  m_match([[U,U,D],[U,D,D]],U,A).
