%%%mode(m_match,[+,+,+]).
%%%mode(match,[+,+,+]).
%%%mode(app,[-,-,+]).
%%%mode(match_int,[+,+,+]).


m_match([W|Ws],K,T) :-
	match(W,K,T).
m_match([W|Ws],K,T) :-
	m_match(Ws,K,T).

match(W,K,T) :-
	app(Z,_,T),       
	app(Left,W1,Z),
	match_int(W,K,W1).


app([],L,L).
app([A|L1],L2,[A|L3]):-
	app(L1,L2,L3).


match_int([],_,[]).
match_int([A|B],K,[C|D]) :-
	{A>=C,
	A-C=<K},
	match_int(B,K,D).
match_int([A|B],K,[C|D]) :-
	{A<C,C-A=<K},
	match_int(B,K,D).



%%% solver:clpq
%%% uf: leftmost_weak_consumer
%%% wqounf: none
%%% Z=:=0, U=:=1, D=:=2, T=:=3, Q=:=4,

mm1(A) :-  {U=:=1, D=:=2}, m_match([[U,U],[U,D]],U,A).

sp_mm1_11(A).
sp_mm1_8(A).
sp_mm1_7(A).
sp_mm1(A) :- sp_mm1_2(A).
sp_mm1_2([A|B]) :- {A>=0, A=<1}, sp_mm1_3(B).
sp_mm1_2([A|B]) :- {A<0}, sp_mm1_2(B).
sp_mm1_2([A|B]) :- {A>1, A=<2}, sp_mm1_3(B).
sp_mm1_2([A|B]) :- {A>2}, sp_mm1_2(B).
sp_mm1_3([A|B]) :- {A>1, A=<2}, sp_mm1_7(B).
sp_mm1_3([A|B]) :- {A=:=1}, sp_mm1_8(B).
sp_mm1_3([A|B]) :- {A>=0, A<1}, sp_mm1_7(B).
sp_mm1_3([A|B]) :- {A<0}, sp_mm1_2(B).
sp_mm1_3([A|B]) :- {A>2, A=<3}, sp_mm1_11(B).
sp_mm1_3([A|B]) :- {A>3}, sp_mm1_2(B).


/*

{D=:=2, Q=:=4}, mm1([D,Q,D,Q,D,Q,D,Q,D,Q,
                     D,Q,D,Q,D,Q,D,Q,D,Q,
                     D,Q,D,Q,D,Q,D,Q,D,Q,
                     D,Q,D,Q,D,Q,D,Q,D,Q,
                     D,Q,D,Q,D,Q,D,Q,D,Q,
                     D,Q,D,Q,D,Q,D,Q,D,Q,
                     D,Q,D,Q,D,Q,D,Q,D,Q,
                     D,Q,D,Q,D,Q,D,Q,D,Q,
                     D,Q,D,Q,D,Q,D,Q,D,Q,
                     D,Q,D,Q,D,Q,D,Q,D,Q,D,D]).

% above query takes 4960ms  (repeated  10 times)
% specialized version takes 110ms
% Speedup 45.1


*/

%%% TODO
%%% sp_mm(A) :-  U=:=1, D=:=2, m_match([[U,U,U],[U,U,D]],D,A).
%%% sp_mm(A) :-  U=:=1, D=:=2, m_match([[U,U,U],[U,U,D],[U,U]],D,A). 
%%% sp_mm(A) :-  U=:=1, D=:=2,  T=:=3, m_match([[U,U,D],[U,D,T]],D,A).
%%% sp_mm(A) :-  U=:=1, D=:=2,  m_match([[U,U,D],[U,D,D]],U,A).