mode(in_language,[+,+]).
mode(accepts,[+,+]).
mode(app,[-,-,+]).
mode(ne_app,[-,-,+]).
mode(symbol,[+]).
mode(string,[+]).



in_language(E,S) :- string(S), accepts(E,S).

accepts( S ,[S]) :- symbol(S).

accepts( (E1,E2), S) :-
        app(S1,S2,S),
        accepts(E1,S1),
        accepts(E2,S2).

accepts( E1+E2, S) :- accepts(E1,S).
accepts( E1+E2, S) :- accepts(E2,S).

accepts( star(E), []).

%accepts( star(E), S) :-     This tautology can be discarded
%        accepts(E,[]),
%        accepts(star(E),S).

accepts( star(E), S) :-
        ne_app(S1,S2,S),
        accepts(E,S1),
        accepts(star(E),S2).

symbol(a).
symbol(b).

app([],L,L).
app([A|L1],L2,[A|L3]):-
        app(L1,L2,L3).

ne_app([A],L,[A|L]).
ne_app([A|L1],L2,[A|L3]) :-
        ne_app(L1,L2,L3).

string([]).
string([a|S]) :- string(S).
string([b|S]) :- string(S).



%%% solver:none
%%% uf: leftmost_consumer
%%% wqounf: none
% %%% INITIAL DEFINITION
% sp_in_lang(W) :- in_language((a,(star(a),b))+(a,star(a)),W).
% sp_in_lang(W) :- in_language((a,(star(a),b)),W).
% sp_in_lang(W) :- in_language((a,(star(a+b),b)),W).
% sp_in_lang(W) :- in_language(star(star(a)),W).
% sp_in_lang(W) :- in_language(star((a,(star(a),b))),W).
