mode(in_language,[+,+]).
mode(accepts,[+,+]).
mode(app,[-,-,+]).
mode(ne_app,[-,-,+]).
mode(symbol,[+]).
mode(string,[+]).



in_language(E,S) :- string(S), accepts(E,S).

%accepts( eq(S1) ,[S2]) :- S2 =:= S1.
accepts( lt(S1) ,[S2]) :- S2 < S1.
%accepts( leq(S1) ,[S2]) :- S2 =< S1.
accepts( gt(S1) ,[S2]) :- S2 > S1.
%accepts( geq(S1) ,[S2]) :- S2 >= S1.
accepts( int(A,B) ,[S2]) :- S2 > A, S2 < B.

accepts( (E1,E2), S) :-
        app(S1,S2,S),
        accepts(E1,S1),
        accepts(E2,S2).

accepts( E1+E2, S) :- accepts(E1,S).
accepts( E1+E2, S) :- accepts(E2,S).

accepts( star(E), []).

%accepts( star(E), S) :-     This tautology can be discarded
%        accepts(E,[]),
%        accepts(star(E),S).

accepts( star(E), S) :-
        ne_app(S1,S2,S),
        accepts(E,S1),
        accepts(star(E),S2).

app([],L,L).
app([A|L1],L2,[A|L3]):-
        app(L1,L2,L3).

ne_app([A],L,[A|L]).
ne_app([A|L1],L2,[A|L3]) :-
        ne_app(L1,L2,L3).

string([]).
string([_|S]) :- string(S).




%%% solver:clpq
%%% uf: leftmost_consumer
%%% wqounf: none

%%% INITIAL DEFINITION
%%% sp_in_lang(W) :- U=:=1, D=:=2, in_language(((gt(U),(star(gt(U)),lt(D)))+(gt(U),star(gt(U)))),W).

%%% newp3([]).
%%% newp3([A]) :- A<2.
%%% newp3([A|B]) :- A>1, newp4(B).
%%% newp4([]).
%%% newp4([A]) :- A<2.
%%% newp4([A|B]) :- A>1, newp4(B).
%%% sp_in_lang(A) :- newp2(A).
%%% newp2([A|B]) :- A>1, newp3(B).


%%% by inverting terms inside the r.e. we derive a different program
%%% sp_in_lang(W) :- U=:=1, D=:=2, in_language(((gt(U),star(gt(U))+(gt(U),(star(gt(U)),lt(D))))),W).

%%%sp_in_lang(A) :- newp2(A).
%%%newp2([A|B]) :- A>1, newp3(B).
%%%newp3([]).
%%%newp3([A|B]) :- A>1, newp4(B).
%%%newp4([]).
%%%newp4([A]) :- A<2.
%%%newp4([A|B]) :- A>1, newp5(B).
%%%newp5([]).
%%%newp5([A]) :- A<2.
%%%newp5([A|B]) :- A>1, newp5(B).


%%% sp_in_lang(W) :- Z=:=0, U=:=1, in_language(((gt(U),star(gt(U))+(gt(U),(star(gt(U)),lt(Z))))),W).

%%%sp_in_lang(A) :- newp2(A).
%%%newp2([A|B]) :- A>1, newp3(B).
%%%newp3([]).
%%%newp3([A|B]) :- A>1, newp4(B).
%%%newp4([]).
%%%newp4([A]) :- A<0.
%%%newp4([A|B]) :- A>1, newp5(B).
%%%newp5([]).
%%%newp5([A]) :- A<0.
%%%newp5([A|B]) :- A>1, newp5(B).


%%% sp_in_lang(W) :- U=:=1, D=:=2, T=:=3, in_language(( star(int(U,D)) + star(int(U,T) )),W).

%%%sp_in_lang(A) :- newp2(A).
%%%newp2([]).
%%%newp2([A|B]) :- A>1, A<2, newp3(B).
%%%newp2([A|B]) :- A>=2, A<3, newp4(B).
%%%newp3([]).
%%%newp3([A|B]) :- A>1, A<2, newp3(B).
%%%newp3([A|B]) :- A>=2, A<3, newp4(B).
%%%newp4([]).
%%%newp4([A|B]) :- A>1, A<3, newp4(B).


%%% sp_in_lang(W) :- Z=:=0, U=:=1, D=:=2, T=:=3, in_language(( star(int(Z,D)) + star(int(U,T) )),W).

%%%sp_in_lang(A) :- newp2(A).
%%%newp2([]).
%%%newp2([A|B]) :- A>1, A<2, newp3(B).
%%%newp2([A|B]) :- A>=2, A<3, newp4(B).
%%%newp2([A|B]) :- A>0, A=<1, newp5(B).
%%%newp5([]).
%%%newp5([A|B]) :- A>0, A<2, newp5(B).
%%%newp4([]).
%%%newp4([A|B]) :- A>1, A<3, newp4(B).
%%%newp3([]).
%%%newp3([A|B]) :- A>1, A<2, newp3(B).
%%%newp3([A|B]) :- A>0, A=<1, newp5(B).
%%%newp3([A|B]) :- A>=2, A<3, newp4(B).


