% problem data as predicate p273.
problem([task(j1,3,[],m1), task(j2,8,[],m1), task(j3,8,[j4,j5],m1),
         task(j4,6,[],m2), task(j5,3,[j1],m2), task(j6,4,[j1],m2)]).


% schedule program p273--274.
schedule(Data, End, Joblist)   :-    
         makejoblist(Data, Joblist, End), 
         precedences(Data, Joblist),
         machines(Data, Joblist),
         labeltasks(Joblist).   
% 
makejoblist([],[],_). 
makejoblist([task(N,D,_,_)|Ts], [job(N,D,TS)|Js], End)  :-  
        TS #>= 0, TS #=< 1000,
        TS + D #=< End,
        makejoblist(Ts, Js, End).       

getjob(JL, N, D, TS)  :- member(job(N,D,TS), JL). 
 
precedences([],_). 
precedences([task(N,_,Pre,_)|Ts], Joblist)  :- 
        getjob(Joblist, N, _, TS),
            prectask(Pre, TS, Joblist),
            precedences(Ts, Joblist).   
 
prectask([],  _, _).
prectask([Name|Names], PostStart, Joblist)  :-
        getjob(Joblist, Name, D, TS),
	TS + D #=< PostStart,
        prectask(Names, PostStart, Joblist).        
 
machines([], _).
machines([task(N,_,_,M)|Ts], Joblist)  :-
        getjob(Joblist, N, D, TS),
	machtask(Ts, M, D, TS, Joblist),
	machines(Ts, Joblist).      
 
machtask([], _, _, _, _).
machtask([task(SN,_,_,M0)|Ts], M, D, TS, Joblist)  :- 
	M #= M0,
	getjob(Joblist, SN, SD, STS),
	exclude(D, TS, SD, STS),
	machtask(Ts, M, D, TS, Joblist).    
machtask([task(SN,_,_,M0)|Ts], M, D, TS, Joblist)  :- 
	M #\= M0,
	machtask(Ts, M, D, TS, Joblist).    
 
exclude(_D, TS, SD, STS)  :-  STS + SD #=< TS. 
exclude(D, TS, _SD, STS)  :-  TS + D #=< STS. 
 
labeltasks([]). 
labeltasks([job(_,_,TS)|Js])   :-   
     indomain(TS),
     labeltasks(Js).
 
% goal for finding a schedule p274.
gp274(Joblist) :-
     End #= 20, problem(Problem), schedule(Problem, End, Joblist).