% Given a pattern P and a string S, find whether S contains a substring P' of the same length
% of P such that the sum of the elements of P is equal to that of P'

:- use_module(library(clpq)).

%% Initial definition
%% sm_xx3(E1,E2,E3,X) :- {E1+E2+E3=<5, E1>=0,E2>=0,E3>=0},sm([E1,E2,E3],X).
% Solver clp(Q)
% Unfold leftmost_determinate
% Wqounf none
% Wqogen embed
% Widening simple


sm_pe3(A,B,C,[D,E,F|S]) :- {A+B+C=<5,A>=0,B>=0,C>=0,A+B+C=D+E+F,D>=0,E>=0,F>=0}.
sm_pe3(A,B,C,[D|S]) :- {D>=0},sm_pe3(A,B,C,S).

sm_c3(A,B,C,[D,E,F|S]) :- {A+B+C=D+E+F,D>=0,E>=0,F>=0}.
sm_c3(A,B,C,[D|S]) :- {D>=0},sm_c3(A,B,C,S).

sm_i3(A,B,C,S) :- {I=A+B+C},newp3(S,I).
newp3([D,E,F|S],I) :- {I=D+E+F,D>=0,E>=0,F>=0}.
newp3([D|S],I) :- {D>=0},newp3(S,I).



%% Initial definition
%% sm_xx10(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,X) :-
%%       {A1+A2+A3+A4+A5+A6+A7+A8+A9+A10=<5,
%%        A1>=0,A2>=0,A3>=0,A4>=0,A5>=0,
%%        A6>=0,A7>=0,A8>=0,A9>=0,A10>=0},
%%       sm([A1,A2,A3,A4,A5,A6,A7,A8,A9,A10],X).
%
% Solver clp(Q)
% Unfold leftmost_determinate
% Wqounf embed_body
% Wqogen embed
% Widening simple



sm_pe10(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,[D1,D2,D3,D4,D5,D6,D7,D8,D9,D10|S]) :- {A1+A2+A3+A4+A5+A6+A7+A8+A9+A10=<5,A1>=0,A2>=0,A3>=0,A4>=0,A5>=0,A6>=0,A7>=0,A8>=0,A9>=0,A10>=0,A1+A2+A3+A4+A5+A6+A7+A8+A9+A10=D1+D2+D3+D4+D5+D6+D7+D8+D9+D10,D1>=0,D2>=0,D3>=0,D4>=0,D5>=0,D6>=0,D7>=0,D8>=0,D9>=0,D10>=0}.
sm_pe10(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,[D|S]) :- {D>=0},sm_pe10(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,S).

sm_c10(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,[D1,D2,D3,D4,D5,D6,D7,D8,D9,D10|S]) :- {A1+A2+A3+A4+A5+A6+A7+A8+A9+A10=D1+D2+D3+D4+D5+D6+D7+D8+D9+D10,D1>=0,D2>=0,D3>=0,D4>=0,D5>=0,D6>=0,D7>=0,D8>=0,D9>=0,D10>=0}.
sm_c10(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,[D|S]) :- {D>=0},sm_c10(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,S).


sm_i10(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,S) :- {I=A1+A2+A3+A4+A5+A6+A7+A8+A9+A10},newp10(S,I).
newp10([D1,D2,D3,D4,D5,D6,D7,D8,D9,D10|S],I) :- {I=D1+D2+D3+D4+D5+D6+D7+D8+D9+D10,D1>=0,D2>=0,D3>=0,D4>=0,D5>=0,D6>=0,D7>=0,D8>=0,D9>=0,D10>=0}.
newp10([D|S],I) :- {D>=0},newp10(S,I).

sm(P,S) :- {LP=LQ,N=M},myprefix(Q,S),
	mylength(P,LP),mylength(Q,LQ),
	sum(P,N),sum(Q,M).

sm(P,[X|Xs]) :- {X>=0},sm(P,Xs).


sum([],N) :- {N=0}.
sum([X|Xs],N) :- {X>=0,N>=0,N=X+N1},
	sum(Xs,N1).

% do NOT use length: it's a built-in predicate (length/2)

mylength([],N) :- {N=0}.
mylength([X|Xs],N) :- {X>=0,N>0,N=N1+1},
	mylength(Xs,N1).


myprefix([],_).
myprefix([X|Xs],[Y|Ys]) :- {X=Y}, myprefix(Xs,Ys).

%ap([], L, L).
%ap([X|L1], L2, [Y|L3]) :- {X=Y}, ap(L1, L2, L3).


sm2(P,S) :- {LP=LQ,N=M},
	mylength(P,LP),sum(P,N),
	prefix(Q,S),
	mylength(Q,LQ),
	sum(Q,M).

sm2(P,[X|Xs]) :- {X>=0},sm2(P,Xs).

sm3(P,S) :- {LP=LQ,N=M},
	mylength(P,LP),sum(P,N),
	mylength(Q,LQ),sum(Q,M),
	prefix(Q,S).

sm3(P,[X|Xs]) :- {X>=0},sm3(P,Xs).
