% Given a pattern P and a string S, find whether S contains a substring P' of the same length
% of P such that the sum of the elements of P is equal to that of P'


sm_sp(A,B,C,S) :- A+B+C=<5, A>=0, B>=0, C>=0, sm([A,B,C],S).


sm(P,S) :- LP=:=LQ,N=:=M,
	mylength(P,LP),sum(P,N),
	myprefix(Q,S),
	mylength(Q,LQ),sum(Q,M).



sm(P,[X|S]) :- X>=0, sm(P,S).

sum([],N) :- N=:=0.
sum([X|Xs],N) :- X>=0, C>=0, N=:=X+N1, 
	sum(Xs,N1).

% do NOT use length: it's a built-in predicate (length/2)

mylength([],N) :- N=:=0.
mylength([X|Xs],N) :- X>=0, N>0, N=:=N1+1, 
	mylength(Xs,N1).


myprefix([],_).
myprefix([X|Xs],[Y|Ys]) :- X=:=Y, myprefix(Xs,Ys).

%ap([], L, L).
%ap([X|L1], L2, [Y|L3]) :- {X=:=Y}, ap(L1, L2, L3).
