#!/bin/sh


TAR=`which tar`
#GZIP=`which gzip`
DATE=`date +%y%m%d`


case "$1" in
  full)
	 FILENAME=MAPfull${DATE}.tgz
	;;
  patch)
	 FILENAME=MAPpatch${DATE}.tgz
	 PWD=`pwd`
	 LASTBKP=${PWD}/LASTBKP
	 if [ ![ -f $LASTBKP ] ] 
	 then
		  echo $LASTBKP " does not exist.";
		  exit 1;
	 fi
	;;
	 *)
	 echo "Error."
	 exit 1
	 ;;
esac


OUTFILE=~/${FILENAME}


if [ -f ${OUTFILE} ]
then
	 echo ${OUTFILE} "exists.";
	 exit 1;
fi


case "$1" in
  full)
    ${TAR} -cvz -f ${OUTFILE} .
	 exit
	;;
  patch)
	 cd $PWD
	 find ./ -depth -print0 -newer $LASTBKP |  ${TAR} -cvz -f ${OUTFILE} -
	;;
	 *)
	 echo "Error."
	 exit 1
	 ;;
esac




