%%% homeomorphic embedding

goal_homeo_embedded(S,T) :-
	length(S,LS),
	length(T,LT),
	LS=<LT,
	homeo_embedded(S,T).	


homeo_embedded(X,Y) :-
	var(X),
	var(Y),!.

homeo_embedded(_X,Y) :-
%%% here	nonvar(X) holds
	var(Y),!, fail.

homeo_embedded(S,T) :-
	nonvar(S),
	nonvar(T),
	S =.. [F|SArgs],
	T =.. [F|TArgs],	
	list_homeo_embedded(SArgs,TArgs),
	!.
homeo_embedded(S,T) :-
	nonvar(T),
	T =.. [_|TArgs],
	some_homeo_embedded(S,TArgs).

some_homeo_embedded(S,TArgs) :-
	member(A,TArgs),
	homeo_embedded(S,A).

list_homeo_embedded([],[]).
list_homeo_embedded([ST|S],[TT|T]) :-
	homeo_embedded(ST,TT),!,
	list_homeo_embedded(S,T).

