:- discontiguous is_a_wqogen/2.

:- multifile embeds/4.
:- discontiguous embeds/4.

:- discontiguous agrees_with/2.

:- multifile css_param_info/2.
:- discontiguous css_param_info/2.


is_a_wqogen(wqogen_always,_).
embeds(wqogen_always,_,_,_).
agrees_with(_,wqogen_always).
css_param_info(wqogen_always,[display('Always')]).

:- ensure_loaded(['$NEWMAP_DIR/src_sics/homeo_embed']).
is_a_wqogen(wqogen_homeo_body,_).
embeds(wqogen_homeo_body,_Solver,CGoal1,CGoal2) :-
	CGoal1 = bd(_,Atoms1),
	CGoal2 = bd(_,Atoms2),
	goal_homeo_embedded(Atoms2,Atoms1).
agrees_with(_,wqogen_homeo_body).
css_param_info(wqogen_homeo_body,[display('Homeomorfic embedding')]).

is_a_wqogen(wqogen_leftmost_homeo,_).
embeds(wqogen_leftmost_homeo,_Solver,CGoal1,CGoal2) :-
	CGoal1 = bd(_,Atoms1),
	CGoal2 = bd(_,Atoms2),
	Atoms1=[A1|_A1s],
	Atoms2=[A2|_A2s],	
	homeo_embedded(A2,A1).
agrees_with(_,wqogen_leftmost_homeo).
css_param_info(wqogen_leftmost_homeo,[display('Leftmost h.e.')]).


is_a_wqogen(wqogen_leftmost_predicate,_).
embeds(wqogen_leftmost_predicate,_Solver,CGoal1,CGoal2) :-
	CGoal1 = bd(_,[A1]),
	CGoal2 = bd(_,[A2]),
	same_functor(A1,A2,_Arity).
agrees_with(_,wqogen_leftmost_predicate).
css_param_info(wqogen_leftmost_predicate,[display('Leftmost predicate')]).


is_a_wqogen(wqogen_variant,_).
embeds(wqogen_variant,_Solver,CGoal1,CGoal2) :-
	CGoal1 = bd(_,[A1]),
	CGoal2 = bd(_,[A2]),
	variant(A1,A2).
agrees_with(_,wqogen_variant).
css_param_info(wqogen_variant,[display('Variant')]).



is_a_wqogen(wqogen_none,_).
embeds(wqogen_none,_Solver,_CGoal1,_CGoal2) :- fail.
agrees_with(_,wqogen_none).
css_param_info(wqogen_none,[display('None')]).
