:- discontiguous is_a_wqounf/2.

:- multifile embeds/4.
:- discontiguous embeds/4.

:- multifile css_param_info/2.
:- discontiguous css_param_info/2.


:- use_module(library(charsio), [atom_to_chars/2]).




is_a_wqounf(wqounf_always,_).
embeds(wqounf_always,_,_,_).
css_param_info(wqounf_always,[display('Always')]).



is_a_wqounf(wqounf_ctl,_).
embeds(wqounf_ctl,_Solver,CGoal1,_CGoal2) :-
	CGoal1 = bd(_,Atoms1),
	\+ safe_ctl_list(Atoms1).

safe_ctl_list([X|Xs]) :-
	member(A,[X|Xs]),
	safe_ctl(A).

safe_ctl(A) :- is_a_negative_literal(A,_),!,fail.
safe_ctl(A) :-
	functor(A,sat,_),
	arg(2,A,Formula),
	!,
	functor(Formula,Conn,_),
	(
	  memberchk(Conn,[not,and,or])
	;
	  elementary_property(Conn)
	).

elementary_property(Prop) :-
	%%% elementary properties are of the form: el_*
	atom_to_chars(Prop,[101,108,95|_]).

css_param_info(wqounf_ctl,[display('CTL')]).





%%% homeomorphic embedding for the whole body

:- ensure_loaded(['$NEWMAP_DIR/src_sics/homeo_embed']).
is_a_wqounf(wqounf_homeo_body,_).
embeds(wqounf_homeo_body,_Solver,CGoal1,CGoal2) :-
	CGoal1 = bd(_,Atoms1),
	CGoal2 = bd(_,Atoms2),
	goal_homeo_embedded(Atoms2,Atoms1).
css_param_info(wqounf_homeo_body,[display('Homeomorphic embedding')]).


is_a_wqounf(wqounf_leftmost_predicate,_).
embeds(wqounf_leftmost_predicate,_Solver,CGoal1,CGoal2) :-
	CGoal1 = bd(_,Atoms1),
	CGoal2 = bd(_,Atoms2),	
	Atoms1=[A1|_A1s],
	Atoms2=[A2|_A2s],	
	same_functor(A1,A2,_Arity).
css_param_info(wqounf_leftmost_predicate,[display('Leftmost predicate')]).

is_a_wqounf(wqounf_none,_).
embeds(wqounf_none,_Solver,_CGoal1,_CGoal2) :- fail.
css_param_info(wqounf_none,[display('None')]).


%%%%%% homeomorphic embedding for the positive literals in the body
%%%is_a_wqounf(wqounf_homeo_pos_body,_).
%%%embeds(wqounf_homeo_pos_body,Solver,CGoal1,CGoal2) :-
%%%	CGoal1 = bd(_,Atoms1),
%%%	CGoal2 = bd(_,Atoms2),	
%%%	pos_neg_literals(Atoms1,PAtoms1,_),
%%%	pos_neg_literals(Atoms2,PAtoms2,_),	
%%%	goal_homeo_embedded(PAtoms2,PAtoms1).



%%%is_a_wqounf(wqounf_leftmost_homeo,_).
%%%embeds(wqounf_leftmost_homeo,Solver,CGoal1,CGoal2) :-
%%%	CGoal1 = bd(_,Atoms1),
%%%	CGoal2 = bd(_,Atoms2),
%%%	Atoms1=[A1|_A1s],
%%%	Atoms2=[A2|_A2s],	
%%%	homeo_embedded(A2,A1).



%%%is_a_wqounf(wqounf_all_negative,_).
%%%embeds(wqounf_all_negative,Solver,CGoal1,_CGoal2) :-
%%%	CGoal1 = bd(_,Atoms1),
%%%	all_negative_literals(Atoms1).

%%%all_negative_literals([]).
%%%all_negative_literals([A|As]) :-
%%%	is_a_negative_literal(A,_),
%%%	all_negative_literals(As).

