

proc hd   l {lindex $l 0}
proc tail l {lrange $l 1 end}
proc last l {
    return [lrange $l [expr [llength $l]-1] end]
}
proc firsts l {
    return [lrange $l 0 [expr [llength $l]-2] ]
}

proc member {x l} {# true if x is a member of list l
        if {[lsearch -exact $l $x] == -1} {return 0} {return 1}
        }
 

proc null l  {expr { $l == ""}}
proc cons {x l} {return "[list $x] $l"}

proc inv {l} {
    if {[null $l]} {return} 
    return "[inv [tail $l]] [list [hd $l]]"
}

proc before_last {list} {
    set lastpos [expr [llength $list]-1]
    set before [lrange $list 0 [expr $lastpos-1]]
    set last [lrange $list $lastpos end]
    return "$before $last"
}


proc pos_x {lc} {
    regexp "\[0-9\]*\.(\[0-9\]*)" $lc match x  
    return $x
}
proc pos_x_y {lc} {
    regexp "(\[0-9\]*)\.(\[0-9\]*)" $lc match y x
    return "$y $x"
}


proc makeprologlist {l} {
    if {[null $l]} { return"\[\]" }
    if {[null [tail $l]]} {return "\[[hd $l]\]"}
    set list ""
    while {![null [tail $l]]} {
	set list "$list[hd $l],"
        set l [tail $l]}
	return "\[$list[hd $l]\]"

}

proc makeprologselection {selection} {
    puts stdout "selection=$selection"
    if [null $selection] {return "\[\]"}
    foreach sel $selection {
    puts stdout "sel=$sel"
	if [is_a_clause $sel] {
	    lappend l cl([clause_num $sel]) } {
        if [is_an_atom $sel] {
	    lappend l atom([clause_num $sel],[atom_num $sel]) } {
		lappend l law($sel) } } 
	    }
    return [makeprologlist $l]
}





proc lapp_proof_sel {NewSel} {
    global proofSelection
    set l $proofSelection
    set proofSelection ""
    while {![null $l]} {
        if { [contained_in_sel $NewSel [hd $l]]} {set proofSelection "$proofSelection $l" ; return}
        if { [contained_in_sel [hd $l] $NewSel]} {set l [tail $l] } {
	      lappend proofSelection [hd $l] ; set l [tail $l] }
	}
	
	lappend proofSelection $NewSel
}

proc lapp_defs_sel {NewSel} {
    global defSelection
    set l $defSelection
    set defSelection ""
    while {![null $l]} {
        if { [contained_in_defs_sel $NewSel [hd $l]]} {set defSelection "$defSelection $l" ; return}
        if { [contained_in_defs_sel [hd $l] $NewSel]} {set l [tail $l] } {
	      lappend defSelection [hd $l] ; set l [tail $l] }
	}
	
	lappend defSelection $NewSel
}

proc lapp_tags_sel {NewSel} {
    global tagsSelection
    lappend tagsSelection $NewSel
}

proc lapp_tags_defs_sel {NewSel} {
    global deftagsSelection
    lappend deftagsSelection $NewSel
}


proc contained_in_sel {sel1 sel2} {
    expr ([list $sel1]==[list $sel2] ||\
	    [ is_an_atom $sel1] && [is_a_clause $sel2] \
	    && [clause_num $sel1]==[clause_num $sel2])
}

proc contained_in_defs_sel {sel1 sel2} {
    expr ([list $sel1]==[list $sel2])
}

proc empty {selection} {
    expr ([null $selection])
}

proc more_than_one_selection {selection} {
    expr (![null [tail $selection]])
}


proc is_a_clause {selection} {
    expr {[hd [hd $selection]]=="clause"}
}

proc all_clauses {selection} {
    foreach sel $selection {
	if {![is_a_clause $sel]} {return 0} } 
	return 1
}

proc all_atoms {selection} {
    foreach sel $selection {
	if {![is_an_atom $sel]} {return 0} } 
	return 1
}

proc is_an_atom {selection} {
    expr {[hd [hd $selection]]=="atom"}
}


proc is_a_law {selection} {
    expr {![is_an_atom $selection] && ![is_a_clause $selection]}
    
}

proc is_a_head_of_clause {selection} {
    expr {[hd [hd $selection]]=="atom" && [tail [tail [hd $selection]]] < 1}
}

proc cl_or_hd_of_cl_selection {selection} {
#     return [expr ([null [tail $selection]] || [lindex $selection 1] < 1)]
    expr ( [is_a_clause $selection] || [is_a_head_of_clause $selection])
}

proc check_same_body {selection} {
    puts stdout "selection=$selection"
    set first [hd $selection]
    if {[is_a_clause $first]} {
        return "[clause_num $first]  all" }
    if {[not_an_atom $first]} {return "error"}
    set cl [lindex $first 1]
    set atoms [tail [tail $first]]
    set selection [tail $selection]
    foreach sel $selection {
	if {[expr ([not_an_atom $sel] || [lindex $sel 1]!=$cl)]} {
	    return "error"} {
	    lappend atoms [tail [tail $sel]] }
	}
    return "$cl $atoms"
    }    
     

proc not_an_atom {selection} {
#    expr ([null [tail [hd $selection]]])
    expr {[hd [hd $selection]]!="atom"}
}
proc not_a_clause {selection} {
    expr {[hd [hd $selection]]!="clause"}
}

proc not_a_body_atom {selection} {
#    expr [tail [hd $selection]] < 1
    expr {[tail [tail [hd $selection]]] < 1}
}

proc clause_num {selection} {
    return [lindex $selection 1]
}

proc atom_num {selection} {
    return [lindex $selection 2]
}

proc max_pos {} {
    global fontcl fontclnum
    if {$fontcl == "courier10"} {
	set fontclnum "Courier 10 bold"
	set MaxPos 80}
    if {$fontcl == "courier12"} {
	set fontclnum  "Courier 12 bold"
	set MaxPos 70}
    if {$fontcl == "courier14"} {
	set fontclnum "Courier 14 bold"
	set MaxPos 56}
    if {$fontcl == "courier16"} {
	set fontclnum "Courier 16 bold"
	set MaxPos 50}

#     if {$fontcl == "helvetica16"} {
# 	set fontclnum "Helvetica 16 bold"
# 	set MaxPos 50}

    if {$fontcl == "courier18"} {
	set fontclnum "Courier 18 bold"
	set MaxPos 46}
    if {$fontcl == "courier20"} {
	set fontclnum "Courier 20 bold"
	set MaxPos 40}
	return $MaxPos
    
}
puts stdout "basics.tcl compiled"