#!/usr/bin/wish

################################### top #####################################


proc destroy4 {} {
    catch {destroy .currentProg}
    catch {destroy .currentHistory}
    catch {destroy .currentTheory}
    catch {destroy .currentInit_Defs}
    catch {destroy .wSolver}
    catch {destroy .css_param}
    catch {destroy .ds_param}
}

destroy4

set white azure2

#color DodgerBlue2 SteelBlue2 PeachPuff2 turquoise2
#80ccff

catch {destroy .top}
 
frame .top -borderwidth 10 
#-background azure2
pack .top -side top -fill x

################################ menu bar ###################################
 
catch {destroy .menuBar}

menu .menuBar -tearoff 0

.menuBar add cascade -menu .menuBar.file -label "Options" -foreground black \
	-underline 0

menu .menuBar.file -tearoff 0
. configure -menu .menuBar

set m .menuBar.file 
$m add command -label "Fonts..." -foreground black -command "setDefaultFonts" 
$m add sep
$m add command -label "Print..." -foreground black \
	-command "print" -state disabled 
$m add sep
$m add command -label "Run..." -foreground black \
	-command "run" -state disabled 

############################# Top buttons ###################################

button .top.rules  -text Rules -font $font -background #80ccff \
	-foreground black -command { loadMenuRules }
button .top.strategies  -text Strategies  -font $font -background #80ccff \
	-foreground black -command { loadMenuStrategies }




menubutton .top.theory  -text Theory  -font $font -background #80ccff \
	-foreground black -underline 0 -direction below \
	-menu .top.theory.m -relief raised
menu .top.theory.m -tearoff 0
grid .top.theory -row 0 -column 1 -sticky n
set m .top.theory.m

$m add command -label "Load" -foreground black -command { 
 set dirNameTheories $env(NEWMAP_DIR)/Theories
# showTheories 
 show theory
}

$m add command -label "Save" -foreground black -command { save theory }
$m add sep
$m add command -label "Add laws" -foreground black -command { enter_new_laws }
$m add command -label "Delete laws" -foreground black -command { delete_laws }
$m add sep
$m add command -label "Show" -foreground black \
	-command { showCurrentTheory }


bind .top.theory <Enter> "describe_button_theories"
bind .top.theory <Leave> "clear_alertnote"

bind .top.strategies <Enter> "describe_button_strategies"
bind .top.strategies <Leave> "clear_alertnote"

bind .top.strategies <Enter> "describe_button_strategies"
bind .top.strategies <Leave> "clear_alertnote"

bind .top.rules <Enter> "describe_button_rules"
bind .top.rules <Leave> "clear_alertnote"

button .top.help -text Help  -font $font -background #80ccff -foreground black\
	-command { helpMessage }
button .top.quit -text Quit  -font $font  -background #80ccff \
	-foreground black -command { exityesno }


menubutton .top.save -text "Save"  -font $font -background #80ccff \
	-foreground black -direction below -underline 0\
	-menu .top.save.m -relief raised
menu .top.save.m -tearoff 0 
.top.save.m add command -label "Derivation" -foreground black \
	-command { save session }
.top.save.m add command -label "Program" -foreground black \
	-command { save program }
#.top.save.m add command -label "Program as term" -foreground black \
#	-command { save program_as_term }
#.top.save.m add command -label "Program for XSB" -foreground black \
#	-command { save program_for_xsb }
#.top.save.m add command -label "Program for SICStus" -foreground black \
#	-command { save program_for_sicstus }
.top.save.m add command -label "History" -foreground black \
	-command { save history }
.top.save.m add command -label "Theory" -foreground black \
	-command { save theory }
grid .top.save -row 0 -column 1 -sticky n

menubutton .top.show -text "Show"  -font $font -background #80ccff \
	-foreground black -direction below -underline 0\
	-menu .top.show.m -relief raised
menu .top.show.m -tearoff 0 
.top.show.m add command -label "Program" -foreground black \
	-command { prolog update_show_program }
.top.show.m add command -label "History" -foreground black -command { 
	if {[prolog update_show_history]==1} {} { prologfailed} }
.top.show.m add command -label "Theory" -foreground black \
	-command { showCurrentTheory }
.top.show.m add command -label "Init+Defs" -foreground black \
	-command { prolog update_show_init_defs }
grid .top.show -row 0 -column 1 -sticky n




bind .top.quit <Enter> "describe_button_quit"
bind .top.quit <Leave> "clear_alertnote"

bind .top.help <Enter> "describe_button_help"
bind .top.help <Leave> "clear_alertnote"

menubutton .top.session  -text Derivation  -font $font -background #80ccff \
	-foreground black -underline 0 -direction below \
	-menu .top.session.m -relief raised
grid .top.session -row 0 -column 1 -sticky n
menu .top.session.m -tearoff 0

set m .top.session.m
$m add command -label "New" -foreground black -command { 
    set dirNameProg $env(NEWMAP_DIR)/Programs 
    showPrograms }

# $m add command -label "tk_getOpenFile" -foreground black -command { 
#     set filename [tk_getOpenFile]
# 	 puts stdout $filename
# }

$m add command -label "Load" -foreground black -command { 
    set dirNameSessions $env(NEWMAP_DIR)/Sessions
    showSessions }
$m add sep
$m add command -label "Restart" -foreground black -state disabled \
	-command { restartTransformation }

$m add command -label "Undo" -state disabled -foreground black \
	-command { undo }
$m add command -label "Goto" -state disabled -foreground black \
	-command { goto }
$m add sep
$m add cascade -label "Show" -state disabled -foreground black \
	-menu $m.show -underline 0
$m add cascade -label "Save" -state disabled -foreground black \
	-menu $m.save -underline 0

set m .top.session.m.save
menu $m -tearoff 0
$m add command -label "Program" -foreground black -command { save program }
#$m add command -label "Program as term" -foreground black \
#	-command { save program_as_term }
#$m add command -label "Program for XSB" -foreground black \
#	-command { save program_for_xsb }
$m add command -label "History" -foreground black -command { save history }
$m add command -label "Theory" -foreground black -command { save theory }
$m add command -label "Derivation" -foreground black -command { save session }

set m .top.session.m.show
menu $m -tearoff 0
$m add command -label "Program" -foreground black \
	 \-command { prolog update_show_program }
$m add command -label "History" -foreground black -command { 
    if {[prolog update_show_history]==1} {} { prologfailed} }
$m add command -label "Theory" -foreground black -command { showCurrentTheory }
$m add command -label "Init+Defs" -foreground black -command { 
    prolog update_show_init_defs }


# button .top.css  -text CSS  -font $font  -background #80ccff \
#  	-foreground black  -command css_param
# bind .top.css <Enter> {infonote "Apply the Contextual Specialization Strategy"}
# bind .top.css <Leave> "clear_alertnote"


# button .top.ds  -text Determinization  -font $font  -background #80ccff \
#  	-foreground black  -command ds_param
# bind .top.ds <Enter> {infonote "Apply the Determinization Strategy"}
# bind .top.ds <Leave> "clear_alertnote"

# menubutton .top.css  -text CSS  -font $font -background #80ccff \
# 	-foreground black -underline 0 -direction below \
# 	-menu .top.css.m -relief raised
# menu .top.css.m -tearoff 0
# grid .top.css -row 0 -column 1 -sticky n
# set m .top.css.m

# $m add command -label "Solver" -foreground black -command { 
#     set dirNameSolvers $env(NEWMAP_DIR)/Solvers
#     showSolvers
# }
# $m add command -label "Unfolding Function" -foreground black -command { 
#     set dirNameUnfoldFuncs $env(NEWMAP_DIR)/UnfoldFuncs
#     showUnfoldFuncs
# }
# $m add command -label "Wqo Unfolding" -foreground black -command { 
#     set dirNameWqounfs $env(NEWMAP_DIR)/Wqounfs
#     showWqounfs
# }
# $m add command -label "Wqo Generalization" -foreground black -command { 
#     set dirNameWqogens $env(NEWMAP_DIR)/Wqogens
#     showWqogens
# }
# $m add command -label "Widenings" -foreground black -command { 
#     set dirNameWidenings $env(NEWMAP_DIR)/Widenings
#     showWidenings
# }
# $m add command -label "Initial Definitions" -foreground black -command { 
#     prolog "update_show_init_defs"
# }


# $m add checkbutton -label "Model Check" -variable enable_mc
# $m add checkbutton -label "Quick Solve" -variable enable_quick_solve 
# $m add checkbutton -label "Apply CCR" -variable enable_ccr 
# $m add checkbutton -label "Apply BUP" -variable enable_bup 

# $m add sep
# $m add command -label "Start" -foreground black -command { 
# ##    apply_transformation_rs "strategy" cs
#     apply_cs_strategy
# }

# $m add sep

# $m add command -label "Solve P wrt head vars" -foreground black -command { 
#     apply_transformation_rs "strategy" solve_program_head_vars
# }

# $m add command -label "Make P propositional" -foreground black -command { 
#     apply_transformation_rs "strategy" make_prop
# }

# $m add sep


# $m add command -label "Bottom-up phase" -foreground black -command { 
#     prolog "tcl_bottom_up_phase"
# }


# menubutton .top.strat  -text Stratification  -font $font -background #80ccff \
# 	-foreground black -underline 0 -direction below \
# 	-menu .top.strat.m -relief raised
# menu .top.strat.m -tearoff 0
# grid .top.stat -row 0 -column 1 -sticky n
# set m .top.strat.m

# $m add command -label "Compute Stratification (new cls)" -foreground black -command { 
#     prolog "tcl_compute_stratification"
# }


pack .top -side top -fill x

pack .top.session  -side left  -padx 3 -pady 3
pack .top.theory  -side left  -padx 3 -pady 3
pack .top.rules  -side left  -padx 3 -pady 3
pack .top.strategies  -side left  -padx 3 -pady 3
#pack .top.css  -side left  -padx 3 -pady 3
#pack .top.ds  -side left  -padx 3 -pady 3



pack .top.quit -side right -padx 3 -pady 3
pack .top.show -side right -padx 3 -pady 3
pack .top.save -side right -padx 3 -pady 3
pack .top.help -side right -padx 3 -pady 3

############################# TMP buttons ###################################

catch {destroy .tmp}

toplevel .tmp 

button .tmp.comp -text Recomp  -font $font -width 4 -background #80ccff \
	-foreground black \
	-command { source $env(NEWMAP_DIR)/src_tcl/display.tcl 
        source $env(NEWMAP_DIR)/src_tcl/help_rules.tcl 
	source $env(NEWMAP_DIR)/src_tcl/basics.tcl 
	source $env(NEWMAP_DIR)/src_tcl/rules.tcl     }

button .tmp.trace -text Trace  -font $font -width 4 -background #80ccff  \
	-foreground black -command { activeTrace }

button .tmp.zip -text Zip  -font $font -width 4 -background #80ccff  \
	-foreground black -command { activeZip }

button .tmp.recompile -text Restart  -font $font -width 4 \
	-background #80ccff  -foreground black\
    -command { source $env(NEWMAP_DIR)/src_tcl/mapMain.tcl} 

pack .tmp.recompile  -padx 3 -pady 3
pack .tmp.comp  -padx 3 -pady 3
pack .tmp.trace -padx 3 -pady 3
pack .tmp.zip -padx 3 -pady 3


############################# Help frame ###################################
catch {destroy .help}
frame .help 
text .help.mess -height 0 -width 115 -relief raised -background azure2 \
    -foreground black -yscrollcommand [list .help.yscrollMess  set] -wrap word
scrollbar .help.yscrollMess -orient vertical -command [list .help.mess  yview]
.help.mess tag configure bigbold -font {Times 14 bold}
.help.mess tag configure italic -font {Times 12 italic}
.help.mess tag configure normal -font {Times 12} -lmargin1 2m -lmargin2 2m -rmargin 2m
.help.mess tag configure bold -font {Times 12 bold}
.help.mess tag configure courier -font {courier 10}
.help.mess tag configure big -font {Times 14}
.help.mess tag configure bigraised -font {Times 14} -relief raised
.help.mess tag configure underline -underline on
.help.mess tag configure center -justify center -font {Times 16 bold}

pack .help -side top -fill x -padx 10 -pady 5
pack .help.mess         -padx 1 -pady 2 -fill x -fill y -side left
pack .help.yscrollMess  -pady 2         -fill y         -side left




############################# Main frames ###################################

catch {destroy .middle}

frame .middle
pack .middle -side top -fill x -pady 10

catch {destroy .middle.proof}

frame .middle.proof 
pack .middle.proof -side right -fill x -padx 10 -pady 10 

catch {destroy .middle.proof.derivation}
set ProofText .middle.proof.derivation
text $ProofText -height 30 -width 80 -relief raised -background azure2\
     -foreground black -yscrollcommand [list .middle.proof.yscrollProof set] \
     -state disabled

scrollbar .middle.proof.yscrollProof -orient vertical \
	-command [list $ProofText yview]


pack .middle.proof.yscrollProof -padx 1 -pady 3 -fill y -side right
pack $ProofText -padx 1 -pady 3 -fill x -fill y 

$ProofText tag configure courier10 -font {Courier 10}
$ProofText tag configure courier12 -font {Courier 12}
$ProofText tag configure courier14 -font {Courier 14}
$ProofText tag configure courier16 -font {Courier 16}
$ProofText tag configure courier18 -font {Courier 18}
$ProofText tag configure courier20 -font {Courier 20}
$ProofText tag configure courierb10 -font {Courier 10 bold}
$ProofText tag configure courierb12 -font {Courier 12 bold}
$ProofText tag configure courierb14 -font {Courier 14 bold}
$ProofText tag configure courierb16 -font {Courier 16 bold}
$ProofText tag configure courierb18 -font {Courier 18 bold}
$ProofText tag configure courierb20 -font {Courier 20 bold}
$ProofText tag configure bold10 -font {Times 10 bold}
$ProofText tag configure bold12 -font {Times 12 bold}
$ProofText tag configure bold14 -font {Times 13 bold}
$ProofText tag configure bold16 -font {Times 14 bold}
$ProofText tag configure bold18 -font {Times 15 bold}
$ProofText tag configure bold20 -font {Times 18 bold}

bind $ProofText <ButtonRelease-1> { break}
bind $ProofText <Triple-1> { break}
bind $ProofText <Double-1> { break}
bind $ProofText <Meta-Double-1> { break}
bind $ProofText <Meta-Triple-1> { break}
bind $ProofText <Shift-1> { break}
bind $ProofText <2> { break}


catch {destroy .middle.control}
frame .middle.control
pack .middle.control -side left -fill x -pady 10 

catch {destroy .middle.control.buttons}
set Control .middle.control.buttons
text $Control -height 30 -width 35 -borderwidth 0 -state disabled
pack $Control -padx 10 -pady 3 -fill x -fill y

# catch {destroy .middle.control.radio}
# set Radio .middle.control.radio
# text $Radio -height 30 -width 35 -borderwidth 0 -state disabled
# pack $Radio -padx 10 -pady 3 -fill x -fill y




$ProofText tag configure italic14 -font {Times 14 italic}
$ProofText tag configure italic12 -font {Times 12 italic}
$ProofText tag configure italic16 -font {Times 16 italic}
$ProofText tag configure times10 -font {Times 10}
$ProofText tag configure times12 -font {Times 12}
$ProofText tag configure times14 -font {Times 14}
$ProofText tag configure times16 -font {Times 16}


################### EXIT

proc exityesno {} {
    if {[ msg_warning_yesno "Be sure you have saved your work before exiting.\n\nContinue exit ?"] == "yes"} { 
	 foreach i [exec ls ] { 
	     if { [regexp "^map_tmp_" $i match] } {exec rm $i} }
	     exit 
	 }
}

proc undo {} {
    if { [prolog clause(current_program(1,_),_)] == 1} {
	msg_warning_ok "No transformation step to undo (initial program)."
	return }
    if { [prolog current_program_is_a_leaf] == 0} {
	msg_warning_ok "Current program is not a leaf. Impossible undo."
	return }
   prolog undo
   if [winfo exists .currentInit_Defs] {
	   if [winfo viewable .currentInit_Defs] {
	       prolog update_show_init_defs } }
}

proc goto {} {
    if { [prolog max_number_program(1)] == 1} {
	msg_warning_ok "No other program to go to\n(no transformation done so far) "
	return }
   get_n_and_goto_n
   if [winfo exists .currentInit_Defs] {
	   if [winfo viewable .currentInit_Defs] {
	       prolog update_show_init_defs } }
}

proc run {} {
    todo
}




puts stdout "control.tcl compiled"


