

proc css_param {} {
 global solver uf wqounf wqogen widening
 global css_params, enable_ccr, enable_bup, enable_quick_solve, enable_mc

 global css_param_done

 set w .css_param
 catch {destroy $w}
 toplevel $w
 wm title $w "Contextual Specialization Strategy Parameters"
 wm iconname $w "CSS Parameters"
 #positionWindow $w


 frame $w.body
 pack $w.body -expand 1 -fill both


 set body $w.body
 label $body.label -font "Helvetica 12" -justify left -text "Step 1: choose the parameters for the Contextual Specialization Strategy."  -anchor w
 pack $body.label -side top -padx 25 -pady 5  -fill x -anchor w

 frame $body.params
 pack $body.params -padx 25 -pady 5

 set css_params {solver uf wqounf wqogen widening}

 set css_params_label(solver) "Constraint solver"
 set css_params_label(uf) "Unfolding function"
 set css_params_label(wqounf) "Wqo unfolding"
 set css_params_label(wqogen) "Wqo generalization"
 set css_params_label(widening) "Widening"

 set arity(solver) 1
 set arity(uf) 2
 set arity(wqounf) 2
 set arity(wqogen) 2
 set arity(widening) 2

 foreach param $css_params {
  prolog "setof(S, is_a($param,$arity($param),S), List)"
  set tcl_list $prolog_variables(List)


  set f $body.params.$param
  frame $f -relief groove -borderwidth 1

  label $f.label -font "Helvetica 10" -text $css_params_label($param)
  pack $f.label -padx 5 -pady 5

  frame $f.sep -relief ridge -bd 1 -height 2
  pack $f.sep -side top -fill x -padx 5 -expand no

  clear_css_alertnote

  frame $f.buttons
  foreach i $tcl_list {
   # get display name and description
   prolog "tcl_css_param_info($i,D,Desc)"
   set display_label $prolog_variables(D)
   set desc_label $prolog_variables(Desc)


   radiobutton $f.buttons.$i -variable $param -value $i -text $display_label -relief flat  -anchor w 
   bind $f.buttons.$i <Enter> "css_infonote \"$desc_label \""
   bind $f.buttons.$i <Leave> "clear_css_alertnote"
   bind $f.buttons.$i <Button> "prolog \"set_current($param,$i)\""

   pack $f.buttons.$i -side top -pady 2 -anchor w -fill x

  }
  pack $f.buttons -padx 1 -fill x 
  pack $f -side left -fill both -padx 5 -pady 5
 }


# label $body.infonote -font "Helvetica 10" -justify left -text ""
# pack $body.infonote -side top -padx 5 -pady 5

 frame $body.labbut

 set f $body.labels
 frame $f
 label $f.l0 -font "Helvetica 12" -justify left -text "Step 1a: optional, partially overrides Step 1 " -anchor w
 label $f.l1 -font "Helvetica 12" -justify left -text "Step 2: select definitions " -anchor w
 label $f.l2 -font "Helvetica 12" -justify left -text "Step 3: specialize program " -anchor w
 pack $f.l0 $f.l1 $f.l2  -pady 5 -in  $f -fill x  -anchor w
 pack $f -padx 25 -side left -anchor w -in $body.labbut

 set f $body.buttons
 frame $f
 checkbutton $f.b0 -text Verification -variable enable_mc -command {
  if {$enable_mc == 1} {
   prolog "set_current(mc,yes),set_current(widening,pred_abs),set_current(wqogen,wqogen_always)"
  } {
   prolog "set_current(mc,no)"  
  }
 }

 button $f.b1 -text Definitions -command {prolog "update_show_init_defs"}
# button $f.b2 -text Specialize -command {  apply_cs_strategy }
 button $f.b2 -text Specialize -command {
  set enable_ccr 1
  set enable_bup 1
  set enable_quick_solve 0
  catch {destroy .css_param}
  set css_param_done 1
 }
 pack $f.b0 $f.b1 $f.b2  -pady 5 -in  $f -fill x -anchor w
 pack $f -padx 25 -side left -in $body.labbut

 pack $body.labbut -anchor w

 vwait css_param_done
}


puts stdout "css_param.tcl compiled"