

proc ds_param {} {

 global enable_ccr

 global solver uf wqounf
 global split_cfacts
 global ds_param_done

 set w .ds_param
 catch {destroy $w}
 toplevel $w
 wm title $w "Determinization Strategy Parameters"
 wm iconname $w "DS Parameters"
 #positionWindow $w


 frame $w.body
 pack $w.body -expand 1 -fill both


 set body $w.body
 label $body.label -font "Helvetica 12" -justify left -text "Step 1: choose the parameters for the Determinization Strategy."  -anchor w
 pack $body.label -side top -padx 25 -pady 5  -fill x -anchor w

 frame $body.params
 pack $body.params -padx 25 -pady 5

 set ds_params {solver uf wqounf}

 set ds_params_label(solver) "Constraint solver"
 set ds_params_label(uf) "Unfolding function"
 set ds_params_label(wqounf) "Wqo unfolding"

 set arity(solver) 1
 set arity(uf) 2
 set arity(wqounf) 2
 set arity(wqogen) 2
 set arity(widening) 2

 foreach param $ds_params {
  prolog "setof(S, is_a($param,$arity($param),S), List)"
  set tcl_list $prolog_variables(List)


  set f $body.params.$param
  frame $f -relief groove -borderwidth 1

  label $f.label -font "Helvetica 10" -text $ds_params_label($param)
  pack $f.label -padx 5 -pady 5

  frame $f.sep -relief ridge -bd 1 -height 2
  pack $f.sep -side top -fill x -padx 5 -expand no

  clear_ds_alertnote

  frame $f.buttons
  foreach i $tcl_list {
   # get display name and description
   prolog "tcl_css_param_info($i,D,Desc)"
   set display_label $prolog_variables(D)
   set desc_label $prolog_variables(Desc)


   radiobutton $f.buttons.$i -variable $param -value $i -text $display_label -relief flat  -anchor w 
   bind $f.buttons.$i <Enter> "ds_infonote \"$desc_label \""
   bind $f.buttons.$i <Leave> "clear_ds_alertnote"
   bind $f.buttons.$i <Button> "prolog \"set_current($param,$i)\""

   pack $f.buttons.$i -side top -pady 2 -anchor w -fill x

  }
  pack $f.buttons -padx 1 -fill x 
  pack $f -side left -fill both -padx 5 -pady 5
 }


# label $body.infonote -font "Helvetica 10" -justify left -text ""
# pack $body.infonote -side top -padx 5 -pady 5

 frame $body.labbut

 set f $body.labels
 frame $f
 label $f.l0 -font "Helvetica 12" -justify left -text "Split constrained facts? " -anchor w
 label $f.l1 -font "Helvetica 12" -justify left -text "Step 2: select definitions " -anchor w
 label $f.l2 -font "Helvetica 12" -justify left -text "Step 3: specialize program " -anchor w
 pack $f.l0 $f.l1 $f.l2  -pady 5 -in  $f -fill x  -anchor w
 pack $f -padx 25 -side left -anchor w -in $body.labbut

 set f $body.buttons
 frame $f

 checkbutton $f.b0 -text Split -variable split_cfacts -command {
  if {$split_cfacts == 1} {
   prolog "set_current(split_cfacts,yes)"
  } {
   prolog "set_current(split_cfacts,no)"
  }
 }
 prolog "set_current(ccr,yes)"

 button $f.b1 -text Definitions -command {prolog "update_show_init_defs"}
# button $f.b2 -text Specialize -command {  apply_ds_strategy }
 button $f.b2 -text Specialize -command { catch {destroy .ds_param}; set ds_param_done 1}

 pack $f.b0 $f.b1 $f.b2  -pady 5 -in  $f -fill x -anchor w
 pack $f -padx 25 -side left -in $body.labbut

 pack $body.labbut -anchor w

 vwait ds_param_done
}


puts stdout "ds_param.tcl compiled"