proc helpMessage {} {
    global help 
    set w .help.mess
    if $help { set help 0
        $w configure -state normal
        clearHelp
        $w configure -state disabled
        .help.mess configure -height 0
        .help.mess delete 1.0 end
	    return }
    set help 1
    generalhelpMessage }

proc generalhelpMessage {} {
     set w .help.mess
    $w configure -state normal
    clearHelp
    showHelp2 "General help\n\n" center
    showHelp "To close this Help window, press again the \"Help\" Button.
The following describes the main windows and menus of the system.\n\n"
    showHelp2 "Windows\n" bigraised
$w insert end {Help} w0 
$w insert end {  }
$w insert end {Current program} w1 
$w insert end {  }
$w insert end {Init+Defs} w2
$w insert end {  }
$w insert end {Theory} w3
$w insert end {  }
$w insert end {History} w4
$w insert end {  }
$w insert end {Alert} w5
$w insert end \n\n
    set Pos1 [$w index insert]
    showHelp2 "Help\n" bigbold
    showHelp3 help_window
$w insert end \n\n
    set Pos2 [$w index insert]
    showHelp2 "Current program\n" bigbold
    showHelp3 current_program_window
$w insert end \n\n
    set Pos6 [$w index insert]
    showHelp2 "Alert\n" bigbold
    showHelp3 alert_window
$w insert end \n\n
    set Pos3 [$w index insert]
    showHelp2 "Init+Defs\n" bigbold
    showHelp3 init_defs_window
$w insert end \n\n
    set Pos4 [$w index insert]
    showHelp2 "Theory\n" bigbold
    showHelp3 theory_window
$w insert end \n\n
    set Pos5 [$w index insert]
    showHelp2 "History\n" bigbold
    showHelp3 history_window
$w insert end \n\n
    lappend Pos $Pos1 $Pos2 $Pos6 $Pos3 $Pos4 $Pos5 
    help_tags_bindings w $Pos
showHelp2 "Buttons and pull-down menus\n" bigraised
$w insert end {Derivation} d0 
$w insert end {  }
$w insert end {Theory} d1 
$w insert end {  }
$w insert end {Rules} d2
$w insert end {  }
$w insert end {Strategies} d3
$w insert end {  }
$w insert end {Help} d4
$w insert end {  }
$w insert end {Save} d5
$w insert end {  }
$w insert end {Quit} d6
$w insert end \n\n
    set pos1 [$w index insert]
    showHelp2 "Derivation\n" bigbold
    showHelp " This is a pull-down menu with the following items:\n"
    showHelp2 "New: " bold
    showHelp "This opens a new window which lists all files stored in the directory Programs/.
Double-click on a file to select it and then press the button \"Load\" if you want to start a new derivation with the selected file as initial program.
Press the button \"Edit\" if you want to edit it before loading.
When a program is loaded, it is shown in the main window, and you can start the transformation.\n"
    showHelp2 "Load: " bold
    showHelp "This opens a new window which lists all derivations stored in the directory Sessions/.
Double-click on a file to select it and then press the button \"Load\" if you want to load this derivation.
When a derivation is loaded, the current program is shown in the main window.\n" 
    showHelp2 "Restart: " bold
    showHelp "Start a new derivation with the current program as initial program (the current theory is kept for the new derivation if required).\n"
    showHelp2 "Undo: " bold
    showHelp "Undo the last transformation step (i.e. delete the last node which has been added to the transformation tree and go back to its father).
This does not undo actions which have not effect on the transformation tree, like the addition or deletion of laws.\n"
    showHelp2 "Goto: " bold
    showHelp "Move to any program in the transformation tree. It becomes the current program.\n"
    showHelp2 "Show:\n " bold
    showHelp " This is a cascade menu with the following items:\n"
    showHelp2 "   Program: " bold
    showHelp "Clear the main window and show the clauses of the current program.\n"
    showHelp2 "   History: " bold
    showHelp "Show the history in the History window.\n"
    showHelp2 "   Theory: " bold
    showHelp "Show laws in the Theory window.\n"
    showHelp2 "   Init+Defs: " bold
    showHelp "Show the initial program and the (current) set of new definitions in the Init+Defs window. This window is used to select clauses for folding.\n"
    showHelp2 "Save:\n" bold
    showHelp2 "   Program: " bold
    showHelp "Name and save the current program in the directory Progs/.\n"
    showHelp2 "   History: " bold
    showHelp "Name and save the current history in the directory History/.\n"
    showHelp2 "   Theory: " bold
    showHelp "Save laws in the directory Theories/.\n"
    showHelp2 "   Derivation: " bold
    showHelp "Name and save the current derivation (transformation tree and current theory) in the directory Sessions/.\n\n"
    set pos2 [$w index insert]
    showHelp2 "Theory\n" bigbold
    showHelp " This is a pull-down menu with the following items:\n"
    showHelp2 "Load\n" bold
    showHelp "This opens a new window which lists all theories stored in the directory Theories/.
Double-click on a file to select it and then press the button \"Load\" if you want to load this theory.
Press the button \"Edit\" if you want to edit it before loading.\n"
    showHelp2 "Save\n" bold
    showHelp "Name and save the current theory in the directory Theories/.\n"
    showHelp2 "Add laws\n" bold
    showHelp "This opens a window in which you can edit some laws.
Press \"Add\" to add these laws to the current theory.\n"
    showHelp2 "Delete laws\n" bold
    showHelp "Delete the law(s) selected in the window \"Theory\".
A law that has been used in the transformation tree cannot be deleted.\n"
    showHelp2 "Show laws\n" bold
    showHelp "Show the (current) laws in the window \"Theory\".
This window is used to select laws for applying goal replacement.\n\n"
    set pos3 [$w index insert]
    showHelp2 "Rules\n" bigbold
    showHelp "This button shows a menu of the available transformation rules on the left of the main window.
To apply a rule, press in that menu the corresponding button.
Available transformation rules:\n"
    prolog {showRulesHelp}
    $w configure -state normal
    set pos4 [$w index insert]
    showHelp2 "Strategies\n" bigbold
    showHelp "This button shows a menu of the available strategies on the left of the main window.
To apply a strategy, press in that menu the corresponding button.
Available strategies:\n"
    prolog {showStrategiesHelp}
    $w configure -state normal
    set pos5 [$w index insert]
    showHelp2 "Help\n" bigbold
    showHelp "This button opens and closes the help window.\n\n"
    set pos6 [$w index insert]
    showHelp2 "Save\n" bigbold
    showHelp " This is a pull-down menu with the following items:\n"
    showHelp2 "Program: " bold
    showHelp "Name and save the current program in the directory Progs/.\n"
    showHelp2 "History: " bold
    showHelp "Name and save the current history in the directory History/.\n"
    showHelp2 "Theory: " bold
    showHelp "Save laws in the directory Theories/.\n"
    showHelp2 "Derivation: " bold
    showHelp "Name and save the current derivation (transformation tree and current theory) in the directory Sessions/.\n\n"
    set pos7 [$w index insert]
    showHelp2 "Quit\n" bigbold
    showHelp "This button exits from the system."
    lappend pos $pos1 $pos2 $pos3 $pos4 $pos5 $pos6 $pos7
    help_tags_bindings d $pos
    $w configure -state disabled
}


 

proc clearHelp {} {
    .help.mess configure -height 16 -font *-*-*bold-*-*-13-*
    .help.mess delete 1.0 end
}
proc showHelp {msg} {
    .help.mess insert end $msg normal
}
proc showHelp2 {msg style} {
    .help.mess insert end $msg $style
}

proc help_tags_bindings { d pos} {
    global white
    set w .help
    if {[winfo depth $w] > 1} {
    set bold "-background pink -relief raised -borderwidth 1"
    set normal "-background {} -relief flat"
} else {
    set bold "-foreground $white -background black"
    set normal "-foreground {} -background {}"
}
    set i 0
    while {[lindex $pos $i]!=""} {
	
	$w.mess tag configure $d$i -font normal -underline on 
	$w.mess tag bind $d$i <Any-Enter> "$w.mess tag configure $d$i $bold"
	$w.mess tag bind $d$i <Any-Leave> "$w.mess tag configure $d$i $normal"
	$w.mess tag bind $d$i <1> "tkTextSetCursor $w.mess [expr [lindex [pos_x_y \
	[lindex $pos $i]] 0] + 2].0"
    incr i}
}


proc helpRule {rule} {
    global help white
    set w .help
    $w.mess configure -state normal
    clearHelp
    $w.mess insert end {Go back to general help} d
    $w.mess insert end \n
    showHelp2 "$rule\n" center
    showHelp2 "Use\n" bold
    if {$rule== "define" || $rule== "restrict" || $rule== "fold" || \
	    $rule== "replace_goal" || $rule== "unfold" ||\
	    $rule== "add_clauses" || $rule== "delete_clauses" ||\
	    $rule== "case_split" || $rule== "generalize" ||  $rule== "move_clause" ||\
	    $rule== "move_goal" || $rule== "add_goal" || $rule== "delete_goal" } {
	    prolog "button_name_rule(Name,$rule) "
	    set name $prolog_variables(Name)
	    help_$rule $name} {showHelp "Not yet available"}
    showHelp2 "\nDescription\n" bold
    prolog "help_rule($rule,Msg)"
    showHelp $prolog_variables(Msg)
    if {[winfo depth $w] > 1} {
    set bold "-background pink -relief raised -borderwidth 1"
    set normal "-background {} -relief flat" } else {
    set bold "-foreground $white -background black"
    set normal "-foreground {} -background {}" }
    $w.mess tag configure d  -underline on
    $w.mess tag bind d <Any-Enter> "$w.mess tag configure d $bold"
    $w.mess tag bind d <Any-Leave> "$w.mess tag configure d $normal"
    $w.mess tag bind d <1> { generalhelpMessage }
    $w.mess configure -state disabled
}

proc help_define {name} {
    showHelp "1- Press the button \"$name\".\n"
    showHelp "2- In the \"Definition introduction\" window, edit the new definition clause(s).\n"
    showHelp "\t   If some clause(s) have been selected in the Main window before pressing the button \"$name\", new definitions for folding the selected clauses (if foldable) are proposed.\n"
    showHelp "3- Press \"Define\" to apply the rule.\n\n"
}

proc help_restrict {name} {
    showHelp "1- Select the predicates w.r.t. to which restriction applies (click on some atoms which use those predicates, with the Control key pressed if more than one selection) in the Main window.\n"
    showHelp "2- Press the button \"$name\".\n\n"
}

proc help_unfold {name} {
    showHelp "1- Select in a clause body the atom to be unfolded (click on it)\n"
    showHelp "2- Press the button \"$name\" to apply the rule.\n\n"
}

proc help_fold {name} {
    showHelp "1- Select the clause(s) to be folded (click on the head of each of them, with the Ctrl key pressed if more than one selection) in the main window.\n"
    showHelp "2- Select the clause(s) to be used for folding click on the head of each of them with the Ctrl key pressed) in the \"Init+Defs\" window.\n"
    showHelp "3- Press the button \"$name\".\n\n"
}

proc help_replace_goal {name} {
    showHelp "1- Select in a clause body the atom(s) to replace (click on each of them, with the Ctrl key pressed if more than one selection). \n"
    showHelp "2- Select the law to apply (click on it) in the \"Theory\" window.\n"
    showHelp "3- Press the button \"$name\".\n\n"
}

proc help_move_goal {name} {
    showHelp "1- Select in a clause body the atom(s) to move (click on each of them, with the Ctrl key pressed if more than one selection). \n"
    showHelp "2- Click with the middle button of the mouse on the atom after which the move must operate (the head to indicate the first position in the body).\n"
     showHelp "3- Press the button \"$name\".\n\n"
}

proc help_move_clause {name} {
    showHelp "1- Select a clause to move. \n"
    showHelp "2- Click with the middle button of the mouse on an atom of a clause after which the move must operate (no selection to indicate the first position).\n"
     showHelp "3- Press the button \"$name\".\n\n"
}


proc help_add_goal {name} {
    showHelp "1- Select in a clause body the atom(s) to add, i.e. duplicate, (click on each of them, with the Ctrl key pressed if more than one selection). \n"
    showHelp "2- Press the button \"$name\".\n\n"
}

proc help_delete_goal {name} {
    showHelp "1- Select in a clause body the atom(s) to delete, (click on each of them, with the Ctrl key pressed if more than one selection). \n"
    showHelp "2- Press the button \"$name\".\n\n"
}

proc help_add_clauses {name} {
    showHelp "1- Select the clauses to add, i.e. duplicate, (click on each of them, with the Ctrl key pressed if more than one selection). \n"
    showHelp "2- Press the button \"$name\".\n\n"
}

proc help_delete_clauses {name} {
    showHelp "1- Select the clauses to delete, (click on each of them, with the Ctrl key pressed if more than one selection). \n"
    showHelp "2- Press the button \"$name\".\n\n"
}



proc help_generalize {name} {
    showHelp "1- Select a clause to generalize. \n"
    showHelp "2- Enter a generalization of the selected clause in the window \"generalize\",\n"
    showHelp "(i.e. a clause for which the selected clause is an instance).\n"
    showHelp "3- Press \"Generalize\" to apply the rule.\n\n"
}

proc help_case_split {name} {
    showHelp "1- Select a clause to split. \n"
    showHelp "2- Enter an instance of its head in the window \"case split\".\n"
    showHelp "3- Press \"Split\" to apply the rule.\n\n"
}

proc showHelp3 {f} {
    global env
    set w .help.mess
    set fpath $env(NEWMAP_DIR)/help/$f
    if ![file isfile $fpath] {$w insert end "not available.\n" normal ; return }
    set file [open $fpath]
	while {![eof $file]} {
	    $w insert end [read $file 1024] normal
	}
    close $file
}


puts stdout "help_rules.tcl compiled"
